%CBSalvarDatos Salva los datos en un fichero *.mat

%REVISIONES
%   11/09/03 ABP Creacin de la funcin
%   02/03/09 ABP Adaptacin Matlab R2008a
%
function CBSalvarDatos
%---declarar ENTORNO
global ENTORNO

%---comprobar que ni sol ni t estn vacos
if isempty(ENTORNO.t) || isempty(ENTORNO.sol)
   errordlg('No data to save','ERROR!!');
   return
end

%---leer el fichero
[fichero,ruta]=uiputfile('*.mat','Save data...');

%---comprobar si se ha seleccionado algn fichero
if isnumeric(fichero)
   return
end

%---copiar time
datos(1).variable='time';
datos(1).valor=ENTORNO.t;

%---copiar las dems variables
fin=1+length(ENTORNO.sol);
[datos(2:fin).variable]=deal(ENTORNO.sol.variable);
[datos(2:fin).valor]=deal(ENTORNO.sol.valor);

%---salvar
save([ruta fichero],'datos');

