%CompilarJava Compila un fichero de Modelica
%
%Sintaxis:
%   CompilarJava(directory,filename)
%Entrada:
%   directory: directorio donde se encuentra el fichero
%   filename: nombre del fichero a compilar
%Ejemplo:
%   CompilarJava('c:\mi directorio\,'prueba.moo');

%REVISIONES
%       03/03/09 ABP Crear funcin basa en Compilar de MOO
%
function CompilarJava(directory,filename)
%---declarar variables globales
global MOO_ERRORS ENTORNO

%---limpiar los errores
MOO_ERRORS=[];

%---creamos los campos del error
MOO_ERRORS.maxNum=10; %---TODO: incluirlo como opcin
MOO_ERRORS.count=0;
MOO_ERRORS.list{10}='';

%---comprobar que es correcta la ruta al fichero
if isempty(directory) || isempty(filename)
   return
end

%---compilar
try
    %---leer el directorio actual
	actualcd=cd;   
   
    %--------------------------
    %---GENERAR ROOT y ENTORNO-
    %--------------------------
    MatrizIncidencia([directory filename]);

	%---------------------------   
	%---GENERAR EL EJECUTABLE---
	%---------------------------

	%---construir las funciones de los bloques implicitos 
	for i=1:length(ENTORNO.bloques)
        if strcmp(ENTORNO.bloques(i).tipo,'implicito')
            nombreBloque=['FnBloque' num2str(i)];
            clear (nombreBloque);
            ConstruirFuncionBloque(i,nombreBloque,ruta);
        end
	end

	%---construir la funcion que llamara a la edo (BaseEdo)
	nombreEdo='fun_edo';
	nombreBaseEdo='BaseEdo';
	clear(nombreBaseEdo);
	ConstruirBaseEdo(nombreBaseEdo,nombreEdo,directory);

	%---construir la edo con nombre 'fun_edo'
	clear(nombreEdo);
    ConstruirEdo(nombreEdo,directory);
   
	%---construir la no edo
	nombreNoEdo='fun_noedo';
	clear(nombreNoEdo);
    ConstruirNoEdo(nombreNoEdo,directory);
   
	%----cambiar el directorio
	cd (actualcd);

	%---salvar los datos en el registro
	Registro('guardar','nombreBaseEdo',nombreBaseEdo);
	Registro('guardar','nombreEdo',nombreEdo);
	Registro('guardar','nombreNoEdo',nombreNoEdo);

catch me
    %---manejo de errores
    if strncmp(me.identifier,'MOO:',4)
        GestionErroresJava(me.message);
    else
        rethrow(me);
    end
end