%29/9/04
%Crea un panel donde introducir los datos de la simulacin
%Entrada:
%	ventana=figure donde se va a crear el panel
%	datos=estructura que conteiene los siguientes campos
%		datos(i).nombre=cadena que describe el nombre de la variable
%		datos(i).tipo= 'escalar' | 'intervalo'
%     datos(i).lugar= posicion de la variable dentro de la estructura entorno.infoVars
%Salida:
%	panel=estrutura que contiene la siguiente informacin
%		panel(i).nombre=nombre de la variable
%		panel(i).tipo='escalar' | 'intervalo'
%		panel(i).editor=uicontrol edit
%		panel(i).etiqueta= uicontrol label
%		panel(i).lugar= copia del campo datos(i).lugar
function panel=CrearPanel(ventana,datos)
%Calcular el nmero de columnas del editor
columnas=floor((length(datos)+11)/12);

%crear la estructura de datos de salida
panel=[];

%pintar las columnas
for i=1:columnas
   %primer elemento de la columna
   inicio=12*(i-1)+1;
   final=12*i;
   
   %comprobar limites de final
   if final>length(datos)
      final=length(datos);
   end
   
   %crear la columna del panel
   columnaPanel=CrearColumnaPanel(ventana,datos(inicio:final),i);
   
   %agregar a la salida
   panel=[panel columnaPanel];
end

%-------------------------------------------------------------------------------
%Crea un columna del panel
function panel=CrearColumnaPanel(ventana,datos,columna)
%dimensiones y coordenadas del editor
editX=642;
editY=60;
editAncho=60;
editAlto=20;

%dimensiones de la etiqueta
etiqAncho=60;
etiqAlto=20;

%separacion entre la etiqueta y el editor
separacion=10;

%separacion entre editores
separacionEditor=10;

%separacion entre columnas del editor
separacionColumnas=editAncho+etiqAncho+separacion+10;

%poner la posicion adecuada del editor
editX=editX+separacionColumnas*(columna-1);

%obtener dimensiones y color de la ventana
posicion=get(ventana,'position');
ventanaAlto=posicion(4); %alto de la ventana
color=get(ventana,'color');

%crear los editores
panel=[];
for i=1:length(datos)
   %guardar datos
   panel(i).nombre=datos(i).nombre;
   panel(i).tipo=datos(i).tipo;
   panel(i).lugar=datos(i).lugar;
   panel(i).valor=datos(i).valor;
   
   %crear el editor
   editor=uicontrol(ventana,'style','edit','Position',[editX ventanaAlto-editY editAncho editAlto]...
      ,'string',num2str(datos(i).valor));
   panel(i).editor=editor;
   
   %crear la etiqueta
   etiqueta=uicontrol(ventana,'backgroundColor',color,'style','text','string',datos(i).nombre...
      ,'horizontalalignment','left','position',[editX+editAncho+separacion ventanaAlto-editY etiqAncho etiqAlto]);
   panel(i).etiqueta=etiqueta;
   
   %pasar al siguiente
   editY= editY+editAlto+separacionEditor;
end
