function hf=InterfazSeleccionModelo
%declarar ROOT
global ROOT

%Leer las clases del primer nivel que son de tipo class o model
seleccion=[];
for i=1:length(ROOT.clase(1).hijo)
   iClase=ROOT.clase(1).hijo(i);
   if any(strcmp({'class' 'model'},ROOT.clase(iClase).tipo)) & ~ROOT.clase(iClase).esPartial
      %almacenar la clase
      if isempty(seleccion)
         seleccion(1).nombre=ROOT.clase(iClase).nombre;
         seleccion(1).iclase=iClase;
      else
         pos=length(seleccion)+1;
      	seleccion(pos).nombre=ROOT.clase(iClase).nombre;
			seleccion(pos).iclase=iClase;
      end
   end
end

%poner clase seleccionada por defecto: ninguna
ROOT.iclase=[];

%hacer los handles visibles a la bsqueda
set(0,'ShowHiddenHandles','on');

%dimensiones del cuadro de dilogo
%En la resolucion de pantalla actual que es 1152x864
% 1 pixel=0.85 points
% 1 point= 1/72 inch
% Mi monitor es de 17 inch => ancho=13.6 inch y alto=10.2 inch
%
% Para averiguar las dimensiones de un pixel he utilizado la frmula:
%		1 pixel= (ancho en pulgadas)*72/(resolucion horizontal en pixels) => 1 pixel= 0.85 points (=13.6*72/1152)	
%
% Para averiguar el nmero de points sabiendo que hay x pixels, se utliza la formula:
%		numero_points=0.85*numero_pixels
vancho=300*0.85;
valto=150*0.85;
margen=10*0.85;
bancho=50*0.85;
balto=25*0.85;

%centrar la ventana en el editor de moo
mooposition=get(findobj('tag','IP'),'position');
if isempty(mooposition)
    x=100;
    y=100;
else
    x=mooposition(1)+(mooposition(3)-vancho)/2;
    y=mooposition(2)+(mooposition(4)-valto)/2;
end

%Visualizar los nombres
hf=figure('Units','points'...
   ,'Color',[0.8 0.8 0.8]...
   ,'HandleVisibility','callback'...
   ,'Name','Select class for simulation'...
   ,'MenuBar','none'...
   ,'NumberTitle','off'...
   ,'Position',[x y vancho valto]...
   ,'Tag','ISM'...
   );

%impedir que se pueda hacer resize
set(hf,'resize','off');

hl=uicontrol(hf...	%Lista
   ,'Units','points'...
   ,'BackgroundColor',[0.9 0.9 0.9]...
   ,'Position',[margen 2*margen+balto vancho-2*margen valto-3*margen-balto]...
   ,'String',{seleccion.nombre}...
   ,'Style','listbox'...
   ,'Tag','ISMLista'...
   ,'UserData',seleccion...
   );

hb1=uicontrol(hf...	%boton OK
   ,'Units','points'...
   ,'BackgroundColor',[0.9 0.9 0.9]...
   ,'CallBack','ISMOpcion(''ok'')'...
   ,'Position',[vancho-margen-bancho margen bancho balto]...
   ,'String','OK'...
   ,'Style','pushbutton'...
   ,'Tag','ISMOK'...
   );

hb1=uicontrol(hf...	%boton cancel
   ,'Units','points'...
   ,'BackgroundColor',[0.9 0.9 0.9]...
   ,'CallBack','ISMOpcion(''cancelar'')'...
   ,'Position',[vancho-2*margen-2*bancho margen bancho balto]...
   ,'String','Cancel'...
   ,'Style','pushbutton'...
   ,'Tag','ISMCancel'...
	);