%Descripcion:
%	Lanza un gui que selecciona un conjunto de variables de estado para usarlas como
%	incognitas
%20/9/03 Antonio Belmonte
function varargout=SeleccionIncognitas(accion,varargin)

persistent estados incognitas num 

switch(accion)
case 'inicio'
   %lanzar el cuadro de dialogo
   
   %comprobar el numero de argumentos de la entrada
   if nargin~=4
      return
   end
   
   %leer los argumetos
   estados=varargin{1};
   incognitas=varargin{2};
   num=varargin{3};
   
   %lanzar el cuadro de dialogo
	hfigure=gui_SeleccionIncognitas;

	%encontrar las listas
	listaEstados=findobj(hfigure,'tag','Lista variables de estado');
   listaIncognitas=findobj(hfigure,'tag','Lista incognitas');
   
   %poner las listas
   set(listaEstados,'string',estados);
   set(listaIncognitas,'string',incognitas');
   
   %poner el mensaje
   titulo=findobj(hfigure,'tag','Titulo');
   set(titulo,'string',['Select ' num2str(num) ' state variables']);
   
   %esperar
   waitfor(hfigure);
   
   %devolver los valores
   varargout{1}=estados;
   varargout{2}=incognitas;
   
case 'agregar'
   %mueve una variable de estado a las incognitas
   
   %hallar la vantana
   hfigure=findobj(0,'tag','gui seleccion incognitas');
   
   %hallar las listas
   listaIncognitas=findobj(hfigure,'tag','Lista incognitas');
   listaEstados=findobj(hfigure,'tag','Lista variables de estado');
   
   %pasar el elemento activo de la listaEstado a la listaIncognitas
   %estados=get(listaEstado,'string');
   %incognitas=get(listaIncognitas,'string');
      
   if ~isempty(estados)
      %obtener el elemento activo de la listaEstado
	   valor=get(listaEstados,'value');
      
      %modificar las listas
   	incognitas{end+1}=estados{valor};
   	estados={estados{1:valor-1} estados{valor+1:end}};
   
   	%cambiar el valor
      if valor>length(estados)
         valor=length(estados);
      end
      
   	if valor==0
   		valor=1;
  		end 
   	set(listaEstados,'value',valor)
   
   	%almacenar los cambios
   	set(listaIncognitas,'string',incognitas);
   	set(listaEstados,'string',estados);   
   end
      
case 'quitar'
   %mover una incognita a las variables de estado
   
   %hallar la vantana
   hfigure=findobj(0,'tag','gui seleccion incognitas');
   
   %hallar las listas
   listaIncognitas=findobj(hfigure,'tag','Lista incognitas');
   listaEstados=findobj(hfigure,'tag','Lista variables de estado');
   
   %pasar el elemento activo de la listaEstado a la listaIncognitas
   %estados=get(listaEstado,'string');
   %incognitas=get(listaIncognitas,'string');
   
   if ~isempty(incognitas)
   	%obtener el elemento activo de la listaEstado
   	valor=get(listaIncognitas,'value');
   
   	%modificar las listas
   	estados{end+1}=incognitas{valor};
   	incognitas={incognitas{1:valor-1} incognitas{valor+1:end}};
      
	   %cambiar el valor
      if valor>length(incognitas)
         valor=length(incognitas);
      end
      
   	if valor==0
   		valor=1;
  		end 
   	set(listaIncognitas,'value',valor)
       
   	%almacenar los cambios
   	set(listaIncognitas,'string',incognitas);
   	set(listaEstados,'string',estados);
   end
      
case 'ok'
   %salir
   
   %buscar la ventana
   hfigure=findobj(0,'tag','gui seleccion incognitas');
   
   %leer las listas
   %listaIncognitas=findobj(hfigure,'tag','Lista incognitas');
   %listaEstado=findobj(hfigure,'tag','Lista variables de estado');
   %incognitas=get(listaIncognitas,'string');
   %estado=get(listaEstado,'string');
   
   %comprobar que el nmero de incognitas es el adecuado
   if length(incognitas)~=num
      errordlg('Incorrect number of unknowns','ERROR!!');
      return
   end
   
   %cerrar el cuadro de dialogo
   delete(hfigure)
end      
