function Simular
%declarar ROOT ENTORNO
global ROOT ENTORNO

%activar opciones de menu
ActivarMenu('IPCargarArchivo','on');
ActivarMenu('IPCompilar','on');
ActivarMenu('IPSimular','on');

%mostrar el interfaz simular
if isempty(findobj('tag','IS'))
   InterfazSimular
end

%obtener la figura
ventana=findobj('tag','IS');

%obtener los parametros
datos=[];
iparametros=ObtenerIndiceVars(ENTORNO.infoVars,'parametro');
for i=1:length(iparametros)
   %obtener la variable
   var=ENTORNO.infoVars(iparametros(i));
   
   %crear el dato
   pos=length(datos)+1;
	datos(pos).nombre=var.expresion;
	datos(pos).tipo='escalar';
   datos(pos).lugar=iparametros(i);
   datos(pos).valor=var.valor;
end

%obtener las condiciones iniciales
iestados=ObtenerIndiceVars(ENTORNO.infoVars,'estado');
for i=1:length(iestados)
   %obtener la variable
   var=ENTORNO.infoVars(iestados(i));
   
   %Crear el dato
   pos=length(datos)+1;
   datos(pos).nombre=var.expresion;
	datos(pos).tipo='escalar';
   datos(pos).lugar=iestados(i);
   datos(pos).valor=var.start;
end

%obtener el tiempo
pos=length(datos)+1;
datos(pos).nombre='time';
datos(pos).tipo='intervalo';
datos(pos).lugar=1;
datos(pos).valor=[];

%mostrar el panel donde se preguntan los datos
panel=CrearPanel(ventana,datos);

%guardar el panel en el registro
Registro('guardar','panel',panel);

%activar el zoom
zoom on

%activar la rejilla
grid on

%realizar la simulacin
%CBSimular;