%moo   Arranca moo
%
%Sintaxis:
%       moo
%

%Revisiones:
%   3/7/04  ABP Creacin de la funcin
%   17/2/09 ABP
%               1. Hacer el directorio de moo relativo al directorio donde 
%                  est moo.
%
function moo
%---limpiar el registro
clear Registro
    
%---obtener el directorio base de moo
baseDir=GetBaseDir;

%---comprueba si existe el fichero de opciones
optionsFile=[baseDir 'gui\opcionesmoo.mat'];
opciones=which(optionsFile);

%---asignar valores a las opciones
if isempty(opciones)
   %---por defecto   
   alias=0;	%alias desactivado
   matrices=0; %ver matrices de incidencia
   pantelides=10; %n de veces que se puede aplicar Pantelides 
   noedo=50; %n de puntos por unidad en sistemas no edo
   dirtrabajo=[baseDir 'ejemplos\']; %directorio de trabajo
   dirlibreria=[baseDir 'libreria\']; %directorio de la libreria
   metodointegracion=1; %ode45
   reltol=1e-3;	%error relativo en odexxx
   abstol=1e-6;	%error absoluto en odexxx
   maxstep=[];		%maximo tamao del paso en odexxx
   initialstep=[]; %tamao inicial del paso en odexxx
   
   %---salvar las variables
   save(optionsFile,'alias','matrices','pantelides','noedo','dirtrabajo','dirlibreria' ...
       ,'metodointegracion','reltol','abstol','maxstep','initialstep' ...
       )
else
   %---cargar el fichero de opciones
   load(optionsFile)
end

%---guardar en el registro
Registro('guardar','alias',alias); 
Registro('guardar','matrices',matrices);
Registro('guardar','pantelides',pantelides); 
Registro('guardar','noedo',noedo);
Registro('guardar','dirtrabajo',dirtrabajo);
Registro('guardar','ruta',dirtrabajo);
Registro('guardar','dirlibreria',dirlibreria);
Registro('guardar','metodointegracion',metodointegracion);
Registro('guardar','reltol',reltol);
Registro('guardar','abstol',abstol);
Registro('guardar','maxstep',maxstep);
Registro('guardar','initialstep',initialstep);

%---lanza el interfaz principal
InterfazPrincipal

%---activar slo la opcin de cargar archivo
ActivarMenu('IPCompilar','off');
ActivarMenu('IPSimular','off');