%27-6-04
%Descripcion:
%	Muestra los elementos distintos de cero de una matriz
%Entrada:
%	m=matriz 
%	ejes= elemento axes donde se va  a mostrar la matriz
%  etiqx= nombre de cada tick en el eje x
%	etiqy= nombre de cada tick en el eje y
%	pf= contiene el nmero de fila donde empieza cada caja 
%	pc= contiene el nmero de columna donde empieza cada caja 
function verMatriz(m,ejes,etiqx,etiqy,pf,pc)

	%comprobar que la matriz no est vaca
   if (isempty(m)) 
      return;
   end
   
   %disp(m);
   
	%obtener las dimensiones de la matriz
   [filas,columnas]=size(m);
   
   %poner los lmites de los ejes
   set(ejes,'xlim',[0.5 columnas+0.5],'ylim',[0.5 filas+0.5]);
   set(ejes,'xtick',[1:columnas],'ytick',[1:filas]);
   
   %crear las etqiuetas de los ejes
   set(ejes,'xticklabel',etiqx,'yticklabel',etiqy(length(etiqy):-1:1));
   
   %mostrar los elementos distintos de cero de la matriz
   [y,x]=find(m);
   
   %calcular el tamao del punto
   maximo=max(filas,columnas);
   if maximo<=5
      tamanno=40;
   elseif maximo>=20
      tamanno=10;
   else
      tamanno=40-2*(maximo-5);
   end
   
   %pintar
   axes(ejes);
   cla;
   hold on;
   plot(x,filas-y+1,'b.','markersize',tamanno);
   
   %pintar filas
   dimension=length(pf)-2;
   if(dimension>0)
     	lineax=[0.5+zeros(1,dimension);0.5+columnas*ones(1,dimension)];
     	lineay=[1.5+filas-pf(2:dimension+1);1.5+filas-pf(2:dimension+1)];
     	plot(lineax,lineay,'b');
   end
         
   %pintar columnas
   dimension=length(pc)-2;
   if(dimension>0)
     	lineax=[-0.5+pc(2:dimension+1);-0.5+pc(2:dimension+1)];
   	lineay=[1.5+filas*ones(1,dimension);0.5+zeros(1,dimension)];
   	plot(lineax,lineay,'b');   
	end
    
   hold off;         