
connector puerto
	flow Real i;
	Real v;
end puerto;

partial class Tierra
	puerto p;
	Real v,i;
equation
	v=p.v;
	i=p.i;
	v=0;
end Tierra;

partial class Fuente
	parameter Real VA=5 "Voltaje de la fuente";
	puerto p,n;
	Real v(start=0),i;
equation
	i=p.i;
	n.i+p.i=0;
	v=p.v-n.v;
	v=VA*sin(time);
end Fuente;

partial class Condensador
	parameter Real C=1e-6 "Capacidad del condensador";
	puerto p,n;
	Real v,i;
equation
	i=p.i;
	n.i+p.i=0;
	v=p.v-n.v;
	der(v)=i/C;
end Condensador;

partial class Resistencia
	parameter Real R=1e3 "Resistencia";
	puerto p,n;
	Real v,i;
equation
	i=p.i;
	n.i+p.i=0;
	v=p.v-n.v;
	v=R*i;
end Resistencia;

model circuito
	Tierra t;
	Fuente f;
	Condensador c1,c2;
	Resistencia r1,r2;
equation
	connect(f.n,t.p);
	connect(f.p,c1.p);
	connect(c1.n,r1.p);
	connect(r1.n,r2.p);
	connect(r1.n,c2.p);
	connect(r2.n,t.p);
	connect(c2.n,t.p);
end circuito;