model cstr1
	//---variables de diseo
	parameter Real Tc=290;
	parameter Real q=100;
	parameter Real Caf=1;
	parameter Real Tf=350;
	
	//---parmetros de la reaccin
	parameter Real V=100;
	parameter Real rho=1000;
	parameter Real Cp=.239;
	parameter Real mdeltah=5e4;
	parameter Real EoverR=8750;
	parameter Real k0=7.2e10;
	parameter Real UA=5e4;

	//---variables
	Real Ca(start=0) "Concentracin de A en el reactor";
	Real T(start=290) "Temperatura en el reactor";

equation
	//---Concentracin de A en el reactor
	der(Ca)=q/v*(Caf-Ca)-k0*exp(-EoverR*T)*Ca;
	
	//---Temperatura en el reactor
	der(T)=q/V*(Tf-T)+mdeltaH/(rho*Cp)*k0*exp(-EoverR*T)*ca+UA/(V*rho*Cp)*(Tc-T);

end cstr1;