%Entrada:
%	root: estructura root
%	lugarEspecificador: indice a root.clase
%	pref: prefijo a combinar
%Salida:
%	root: nuevo root
%	nuevoComponente: vector de indices de los nuevos componentes
%Descripcion:
%	Duplica los componentes de lugarEspecificador. Ajustando su prefijo
function nuevoComponente=DuplicarComponentesClase(iEspecificador,pref)
%declarar root
global ROOT

%inicializar
nuevoComponente=[];
componente=ROOT.clase(iEspecificador).componente;

%duplicar cada componente de la clase
for i=1:length(componente)
   nc=DuplicarComponente(componente(i),pref);   
   nuevoComponente(end+1)=nc;
end

%------------------------------------------------------------------------------------------
%Entrada:
%	root: estructura root
%	lugarComponente: indice a root.componente
%	pref: prefijo a combinar
%Salida:
%	root: nuevo root
%	nc: indice del nuevo componente
%Descriopcion:
%	Duplica el componente lugarComponente y sus sub-componentes
function nc=DuplicarComponente(iComponente,pref)
%declarar root
global ROOT

%calcular el prefijo del componente
prefComponente=CombinarPrefijo(ROOT.componente(iComponente).prefijo,pref);

%reservar espacio para el componente
nc=length(ROOT.componente)+1;
ROOT.componente(nc)=ROOT.componente(iComponente); %copiar
ROOT.componente(nc).prefijo=prefComponente;
ROOT.componente(nc).hijo=[];
ROOT.componente(nc).modificacion=[];
ROOT.componente(nc).aplicadaModificacion=0;

%duplicar cada componente del componente si tiene hijos
for i=1:length(ROOT.componente(iComponente).hijo)
   ROOT.componente(nc).hijo(end+1)=DuplicarComponente(ROOT.componente(iComponente).hijo(i),prefComponente);   
end

%Modificar el campo fixed de los hijos
hijos=ROOT.componente(nc).hijo;
if any(strcmp({'Boolean' 'Integer' 'Real'},ROOT.componente(nc).especificador))
   ind=find(strcmp({ROOT.componente(hijos).nombre},'fixed'));
   
   switch(prefComponente)
   case {'constant' 'parameter'}
      ROOT.componente(hijos(ind)).valor=1;
   otherwise
      ROOT.componente(hijos(ind)).valor=0;
   end
end


