%Entrada:
%	iEspecificador: indice del especificador
%	iClase: indice de la clase
%	nombreComponente: nombre del componente que tiene por especificador a iEspecificador
%Descripcion:
%	Duplica las ecuaciones y eventos de iEspecificador en iClase, anteponiendo a la variable
%	el nombre del componente
function DuplicarEcuacionesEspecificador(iEspecificador,iClase,nombreComponente)
%declarar root
global ROOT

%Si hay nombre de componente => anteponerlo a todas las variables de ecuaciones y eventos
if ~isempty(nombreComponente)
	%recorrer todas las ecuaciones de especificador
	for i=1:length(ROOT.clase(iEspecificador).ecuacion)      
   	%agregar la ecuacion a la clase
   	ROOT.clase(iClase).ecuacion{end+1}=CambiarNombreVars(ROOT.clase(iEspecificador).ecuacion{i},nombreComponente);
	end

	%recorrer todos los eventos del especificador
	for i=1:length(ROOT.clase(iEspecificador).evento)
   	%localizar el when
   	iwhen=ROOT.clase(iEspecificador).evento(i);
   
   	%crear el nuevo when
   	pos=length(ROOT.when)+1;
   	for j=1:length(ROOT.when(iwhen).cc)
      	ROOT.when(pos).cc(j).mi=CambiarNombreVars(ROOT.when(iwhen).cc(j).mi,nombreComponente);
      	ROOT.when(pos).cc(j).md=CambiarNombreVars(ROOT.when(iwhen).cc(j).md,nombreComponente);
      	ROOT.when(pos).cc(j).op=ROOT.when(iwhen).cc(j).op;
   	end
   
   	for j=1:length(ROOT.when(iwhen).reinit)
      	ROOT.when(pos).reinit(j).var=CambiarNombreVars(ROOT.when(iwhen).reinit(j).var,nombreComponente);
      	ROOT.when(pos).reinit(j).expresion=CambiarNombreVars(ROOT.when(iwhen).reinit(j).expresion,nombreComponente);
   	end
   
   	%aadirlo al final de los eventos de iclase
   	ROOT.clase(iclase).evento(end+1)=pos;
   end
else
   %copiar ecuaciones
   num=length(ROOT.clase(iEspecificador).ecuacion);
   if num>0
   	[ROOT.clase(iClase).ecuacion{end+1:end+num}]=deal(ROOT.clase(iEspecificador).ecuacion{:});
   end
   
   %copiar eventos
   evento=ROOT.clase(iEspecificador).evento;
   num=length(evento);
   if num>0
      %duplicar los eventos
      inicio=length(ROOT.when)+1;
      final=inicio+num-1;
      [ROOT.when(inicio:final)]=deal(ROOT.when(evento));
      
      %aadirlo a iclase
      ROOT.clase(iClase).evento(end+1:end+num)=[inicio:final];
   end
end

%--------------------------------------------------------------------------------------------------
%Entrada:
%	expr: cadena conteniendo una expresion vlida
%	prefijo: prefijo que se antepone a todas las variables salvo time
function nexpr=CambiarNombreVars(expr,prefijo)
%abrir la ecuacion
token('open',expr);

%recorrer la ecuacion
[tk,s]=token;
nexpr='';
while ~strcmp(tk,'fin') 
   if strcmp(tk,'name')
      %cambiar el nombre de las variables anteponiendo nombreComponente
      if strcmp(s,'time')
         %La variable time no se modifica
         nexpr=[nexpr s];
      else
         nexpr=[nexpr prefijo '.' s];
      end
   else
      nexpr=[nexpr s];
   end
      
   %siguiente token
   [tk,s]=token;
end

%cerrar la expresion
token('close');