%Descripcion:
%	.) Comprueba que no hay elementos con el mismo nombre dentro de la clase -HECHO
%	.) Hace flattening en todas las subclases.  -NO ES NECESARIO
%	.) Hace flattening a todos los componentes. -HECHO
%	.) Pone valores por defecto a los built-in. -HECHO (BOOLEAN, INTEGER, REAL, STRING)
%  .) Comprueba las restricciones de clase
%	.) Fija el prefijo de cada componente y clase -HECHO
%	.) Fija si una clase es paquete
%	.) Rene todas las ecuaciones -HECHO
%	.) Comprueba que las variables de las ecuaciones estn definidas 
%	.) Forma las ecuaciones de connect comprobando errores -HECHO
%  .) Reune todas las ecuaciones de los eventos
%  .) Comprueba que las variables de los eventos son vlidas
function FlatteningClase(iClase)
%declarar root como global
global ROOT

%comprobar que no se ha alcanzado el maximo de la pila
if ROOT.ppila>=ROOT.maxpila;
   nombres='';
   for i=1:ROOT.maxpila
      nombres=[nombres ' ' ROOT.clase(ROOT.pila(i)).nombre];
   end
   ROOT.merr=['$25$' nombres '$'];
   error(ROOT.merr);
else
   %todo bien, almacenar la clase
   ROOT.ppila=ROOT.ppila+1;
   ROOT.pila(ROOT.ppila)=iClase;
end

%obtener el nombre de la clase
nombreClase=ROOT.clase(iClase).nombre;

%comprobar si no se ha hecho flattening
if ROOT.clase(iClase).instanciada==0
   
	%Buscar id de clases y componentes repetidos
	listaClases={}; %nombres de las clases
	hijo=ROOT.clase(iClase).hijo;
	for i=1:length(hijo)
   	id=ROOT.clase(hijo(i)).nombre;
      pos=BuscarVarLista(listaClases,id);
      
      %si est duplicado => error
   	if ~isempty(pos)
      	ROOT.merr=['$2$' nombreClase '$' id '$'];
      	error(ROOT.merr);
   	else
      	listaClases{end+1}=id;
   	end
	end
   
   %nombres de los componentes
	listaComponentes={}; 
	componente=ROOT.clase(iClase).componente; %vector de indices de componentes
   for i=1:length(componente)
      %buscar en clases
   	id=ROOT.componente(componente(i)).nombre;
      pos=BuscarVarLista(listaClases,id);
      
      %si est duplicado => error
		if ~isempty(pos)
      	ROOT.merr=['$2$' nombreClase '$' id '$'];
      	error(ROOT.merr);
   	end
      
      %buscar en componentes
      pos=BuscarVarLista(listaComponentes,id);
      
      %si est duplicado => error
   	if ~isempty(pos)
	   	ROOT.merr=['$2$' nombreClase '$' id '$'];
      	error(ROOT.merr);
   	else
      	listaComponentes{end+1}=id;
   	end
	end
   
   %obtener mi prefijo
	antecesor=ROOT.clase(iClase).padre;
   miPrefijo=ROOT.clase(iClase).prefijo;
   while ~isempty(antecesor)
      miPrefijo=CombinarPrefijo(miPrefijo,ROOT.clase(antecesor).prefijo);
      antecesor=ROOT.clase(antecesor).padre;
   end
      
   %guardarlo
   ROOT.clase(iClase).prefijo=miPrefijo;
      
	%Flattening de los hijos. No es necesario pq se hace si se utilizan
	%for i=1:length(hijo)
   % 	[root,error]=Flattening(root,hijo(i));
   %	if ~isempty(error),return,end
	%end

	%Flattening de los componentes
   for i=1:length(componente)
      %hacer el flattening del componente
      FlatteningComponente(iClase,componente(i),miPrefijo);
   end
   
   %Construir las ecuaciones de las conexiones
   CrearConexiones(iClase);
      
   %inicializar la clase
   InicializarClase(iClase);
   
   %extender la clase
   ExtenderClase(iClase);
   
   %indicar que ya se ha hecho flattening a la clase
   ROOT.clase(iClase).instanciada=1;
end      

%disminuir el puntero de la pila
ROOT.ppila=ROOT.ppila-1;