%Entrada:
%	iClase: indice de la clase
%	iComponente: indice del componente de la clase
%	prefijoClase: prefijo de la clase que actua como modificador
%Descripcion:
%	Hace el Flattening de un componente.Con los siguientes pasos
%		1)Desarrollar componentes
%		2)Copiar ecuaciones
function FlatteningComponente(iClase,iComponente,prefijoClase)
%declarar root
global ROOT

%se ha hecho ya flattenning?
if ROOT.componente(iComponente).instanciada==0   
	%Buscar la clase del especificador
   especificador=ROOT.componente(iComponente).especificador;
         
   switch especificador
   case 'Boolean'
   	%obtener el prefijo del componente
      prefijoComponente=CombinarPrefijo('discrete',prefijoClase,ROOT.componente(iComponente).prefijo);
            
      %guardar el prefijo resultante
      ROOT.componente(iComponente).prefijo=prefijoComponente;
            
      %definir sub-componentes
     	%prefijo=' pppp';
      %almacenado='bsbbb';  
      %nombre={'value' 'quantity' 'start' 'fixed' 'enable'};
      %valor={0 '' 0 1 1 };
      %[root,nuevoComponente]=CrearVectorComponenteBuiltin(root,5,prefijo,prefijoComponente,nombre,valor,almacenado);
      prefijo=' pp';
      almacenado='bbb';  
      nombre={'value' 'start' 'fixed' };
      valor={nan nan 0};
      nuevoComponente=CrearVectorComponenteBuiltin(3,prefijo,prefijoComponente,nombre,valor,almacenado);
      
      %guardar los hijos en el componente
      ROOT.componente(iComponente).hijo=nuevoComponente;
      ROOT.componente(iComponente).almacenado='x';
      ROOT.componente(iComponente).instanciada=1;
      
   case 'Integer'
      %obtener el prefijo del componente
      prefijoComponente=CombinarPrefijo('discrete',prefijoClase,ROOT.componente(iComponente).prefijo);
      
      %guardar el prefijo resultante
      ROOT.componente(iComponente).prefijo=prefijoComponente;
            
      %definir sub-componente
      %prefijo=' pppppp';
      %almacenado='isiiibb';
      %nombre={'value' 'quantity' 'min' 'max' 'start' 'fixed' 'enable'};
      %valor={0  '' -inf +inf 0 1 1 };
      %[root nuevoComponente]=CrearComponenteBuiltin(root,7,prefijo,prefijoComponente,nombre,valor,almacenado);
      prefijo=' pp';
      almacenado='iib';
      nombre={'value' 'start' 'fixed'};
      valor={nan nan 0};
      nuevoComponente=CrearComponenteBuiltin(3,prefijo,prefijoComponente,nombre,valor,almacenado);
      
      %guardar los hijos en el componente
      ROOT.componente(iComponente).hijo=nuevoComponente;
      ROOT.componente(iComponente).almacenado='x';
      ROOT.componente(iComponente).instanciada=1;
      
   case 'Real'
      %obtener el prefijo del componente
      prefijoComponente=CombinarPrefijo(prefijoClase,ROOT.componente(iComponente).prefijo);
            
      %guardar el prefijo resultante
      ROOT.componente(iComponente).prefijo=prefijoComponente;      
            
      %definir sub-componentes
      %prefijo=' ppppppppp';
      %almacenado='rsssrrrbbr';
      %nombre={'value' 'quantity' 'unit' 'displayUnit' 'min' 'max' 'start' 'fixed' 'enable' 'nominal'};
      %valor={0 '' '' '' -inf +inf 0 1 1 0};
      %[root nuevoComponente]=CrearComponenteBuiltin(root,10,prefijo,prefijoComponente,nombre,valor,almacenado);
      prefijo=' ppp';
      almacenado='rsrb';
      nombre={'value' 'unit' 'start' 'fixed' };
      valor={nan '' nan 0};
      nuevoComponente=CrearComponenteBuiltin(4,prefijo,prefijoComponente,nombre,valor,almacenado);

      
      %guardar los hijos en el componente
      ROOT.componente(iComponente).hijo=nuevoComponente;
      ROOT.componente(iComponente).almacenado='x';
      ROOT.componente(iComponente).instanciada=1;
      
   case 'String'
      %obtener el prefijo del componente
      prefijoComponente=CombinarPrefijo('discrete',prefijoClase,ROOT.componente(iComponente).prefijo);
            
      %guardar el prefijo resultante
      ROOT.componente(iComponente).prefijo=prefijoComponente;
            
      %definir sub-componentes      
      %prefijo=' ppp';
      %almacenado='sssb';
      %nombre={'value' 'quantity' 'start' 'enable'};
      %valor={'' '' '' 1};
      %[root nuevoComponente]=CrearComponenteBuiltin(root,4,prefijo,prefijoComponente,nombre,valor,almacenado);
      prefijo=' p';
      almacenado='ss';
      nombre={'value' 'start' };
      valor={'' ''};
      nuevoComponente=CrearComponenteBuiltin(2,prefijo,prefijoComponente,nombre,valor,almacenado);
      
      %guardar los hijos en el componente
      ROOT.componente(iComponente).hijo=nuevoComponente;
      ROOT.componente(iComponente).almacenado='x';
      ROOT.componente(iComponente).instanciada=1;
   otherwise
      iEspecificador=LookupEspecificador(iClase,especificador);
      if isempty(iEspecificador)
         ROOT.merr=['$3$' ROOT.clase(iClase).nombre '$' especificador '$'];
         error(ROOT.merr);
      end
   
   	%Comprobar si se ha hecho flattening en l
      FlatteningClase(iEspecificador);
   
   	%Guardar los nuevos componentes
      nuevoComponente=DuplicarComponentesClase(iEspecificador...
         ,CombinarPrefijo(prefijoClase,ROOT.componente(iComponente).prefijo));
      
      %Poner los dems campos
      ROOT.componente(iComponente).iespecificador=iEspecificador;
      ROOT.componente(iComponente).hijo=nuevoComponente;
      ROOT.componente(iComponente).almacenado='x';
      ROOT.componente(iComponente).instanciada=1;
            
      %reunir las ecuaciones de los componentes
      DuplicarEcuacionesEspecificador(iEspecificador,iClase,ROOT.componente(iComponente).nombre);
   end
end

%---------------------------------------------------------------------------------------------------------
%Entrada:
%	n: nmero de componentes a crear
%	prefijo: prefijo de cada componente
%	almacenado: tipo de dato mquina almacenado
%	nombre: nombre de cada componente
%	valor de cada componente
%Salida:
%	componente: vector de indices de componentes
%Descripcion:
%	Crea un vector de componentes built-in
function componente=CrearComponenteBuiltin(n,prefijo,prefijoComponente,nombre,valor,almacenado)
%declarar root como global
global ROOT

%empezar a copiar
componente=[];
for i=1:n
   %reservar espacio
   lc=length(ROOT.componente)+1;
   componente(end+1)=lc;
   
   %poner prefijo
   switch prefijo(i)
   case 'c'
      ROOT.componente(lc).prefijo=CombinarPrefijo('constant',prefijoComponente);
   case 'p'
      ROOT.componente(lc).prefijo=CombinarPrefijo('parameter',prefijoComponente);
   otherwise
      ROOT.componente(lc).prefijo=prefijoComponente;
   end
   
   %poner especificador. siempre []
   ROOT.componente(lc).especificador='';
   
   %poner el nombre
   ROOT.componente(lc).nombre=nombre{i};
   
   %poner hijo
   ROOT.componente(lc).hijo=[];
   
   %poner valor. Hay que tener cuidado cuando el campo es fixed y el componente padre
   %es constant o parameter
   if strcmp(nombre(i),'fixed')
      if strcmp('constant',prefijoComponente) | strcmp('parameter',prefijoComponente)
         ROOT.componente(lc).valor=1;
      else
         ROOT.componente(lc).valor=0;
		end
   else
   	ROOT.componente(lc).valor=valor{i};
   end
   
   %no se modifica
   ROOT.componente(lc).modificacion=[];
   
   %poner su valor
   ROOT.componente(lc).almacenado=almacenado(i);
   
   %indicar que se ha hecho flattening
   ROOT.componente(lc).instanciada=1;
   
   %indicar que no se ha aplicado la modificacion
   ROOT.componente(lc).aplicadaModificacion=0;
end

