function InicializarClase(iClase)
%declarar ROOT como global
global ROOT

%comprobar que no ha sido instanciada antes
componente=ROOT.clase(iClase).componente;

%inicializar los componentes
for i=1:length(componente)
   InicializarComponente(iClase,componente(i));
end

%indicar que la clase se ha instanciado
ROOT.clase(iClase).instanciada=2;

%----------------------------------------------------------------------------------------------------------------
function InicializarComponente(iClase,iComponente)
%declarar ROOT
global ROOT

%ver si el especificador no es built-in
iEspecificador=ROOT.componente(iComponente).iespecificador;
   
%Copiar los valores del especificador en el componente
if ~isempty(iEspecificador)                       
   CopiarEspecificador(iEspecificador,iComponente);
end

%aplica los valores de la modificacion si existen
if ~isempty(ROOT.componente(iComponente).modificacion)
   AplicarModificacion(iClase,iComponente);
end

%----------------------------------------------------------------------------------------------------------------------------
%Entrada:
%	iEspecificador: indice del especificador (clase)
%	iComponente: indice del componente
%Salida:
%Descripcion:
%	Copia recursivamente el valor de los componentes de iEspecificador en iComponente.
%	iComponente debe tener como especificador iEspecificador
function CopiarEspecificador(iEspecificador,iComponente)
%declarar ROOT
global ROOT

%inicializar
sic=ROOT.clase(iEspecificador).componente; %origen de la copia
dic=ROOT.componente(iComponente).hijo; %destino de la copia

%copiar los campos de uno a otro
while ~isempty(dic)
   [ROOT.componente(dic).valor]=deal(ROOT.componente(sic).valor);
   sic=[ROOT.componente(sic).hijo];
   dic=[ROOT.componente(dic).hijo];
end
