%Salida:
%	posicion: indice de la clase o del componente
%	tipo: 0 para clase
%			1 para componente
function [posicion,tipo]=Lookup(iClase,name)
%declarar ROOT
global ROOT

%posicion
posicion=[];
tipo=[];

%dividir la cadena name
s=[0 find(name=='.') length(name)+1];

%buscar id1
id=name(s(1)+1:s(2)-1);
posicionClase=iClase;      
while ~isempty(posicionClase)   
   %Buscar en clases hijas
   posicion=LookupClase(posicionClase,id);
   if ~isempty(posicion)
      tipo=0;	%busqueda en clase
      break
   end
   
   %Buscar en componentes
	posicion=LookupComponenteEnClase(posicionClase,id);
   if ~isempty(posicion)
      tipo=1;	%busqueda en componente
      break
   end
   
   %subir un nivel hacia arriba
   posicionClase=ROOT.clase(posicionClase).padre;
end

%si no se ha encontrado => buscar en el import
%if isempty(posicionClase)
   %buscar en el import id
%   indices=ROOT.clase(iClase).import;
%   iimport=find(strcmp({ROOT.import(indices).cualificado},id));
%   if ~isempty(iimport)
%      posicionClase=ROOT.import(iimport).hijo;
%   end
%end

%si no se ha encontrado => volver
if isempty(posicionClase)   
   posicion=[];
   return
end

%buscar id2,id3,...,idn
%La bsqueda de idk depende de idk-1
for i=2:length(s)-1
   id=name(s(i)+1:s(i+1)-1);
   
   switch(tipo)
   case 0
      %busqueda en clase
      posicion=LookupClase(posicion,id);
      if ~isempty(posicion)
         tipo=0;
      else
         %busqueda de componente en clase
         posicion=LookupComponenteEnClase(posicion,id)
         if ~isempty(posicion)
            tipo=1;
         else
            return
         end
      end
      
   case 1
      %busqueda en componente
      posicion=LookupComponenteEnComponente(posicion,id);
      if isempty(posicion)
         return
      end
      tipo=1;
   end
end
