function [resp,tipo]=Lookup2(indice,name,tipoOrigen,tipoDestino,tipoBusqueda)
%declarar ROOT
global ROOT

%inicializar
resp=[];
tipo='';

%Trocear name
p=[0 find(name=='.') length(name)+1];

%averiguar el tipo de busqueda
switch tipoOrigen
case 'class'
   %inicializar
   iClase=indice;
   
   %decidir el tipo de bsqueda
   switch tipoDestino
   case 'class'
      %Busqueda de una clase
      if tipoBusqueda=='+'
         %Busqueda hacia arriba
         id=name(p(1)+1:p(2)-1);
         resp=iClase;
         while ~isempty(resp)
            ind=Lookup2ClaseClase(resp,id);
            %Si ind es no vacio => encontrado
            if ~isempty(ind), resp=ind;, break;end
            
            %subir hacia arriba
            resp=ROOT.clase(resp).padre;
         end
         
         %si no se ha encontrado => buscar en el import
			%if isempty(resp)
   			%buscar en el import id
   		%	ind=ROOT.clase(iClase).import;
   		%	iimport=find(strcmp({ROOT.import(ind).cualificado},id));
   		%	if ~isempty(iimport)
      	%		resp=ROOT.import(iimport).clase;
   		%	end
			%end
         
         %si no se ha encontrado => volver
         if isempty(resp),return,end
         
         %Ahora, buscar ahora hacia abajo
      	for i=2:length(p)-1
            id=name(p(i)+1:p(i+1)-1);
            resp=Lookup2ClaseClase(resp,id);
            
            %si no encontrado,volver
            if isempty(resp),return,end
         end
         
         %poner solucion
         tipo='class';
         return
         
      else tipoBusqueda=='-'
         %Busqueda hacia abajo de una subclase en una clase
         resp=iClase;
      	for i=1:length(p)-1
            id=name(p(i)+1:p(i+1)-1);
            resp=Lookup2ClaseClase(resp,id);
            
            %Si no encontrado => volver
            if isempty(resp),return,end
      	end
         
         %poner solucion
         tipo='class';
         return
      end
      
   case 'component'
      %Busqueda de un componente en una clase hacia abajo
      %Primero buscar el componente en la clase
      id=name(p(1)+1:p(2)-1);
		ind=Lookup2ClaseComponente(iClase,id);
      
      %si no encontrado => volver
      if isempty(ind),return,end
      
      %Buscar el resto del nombre
      iComponente=ind;
   	for i=2:length(p)-1
      	id=name(p(i)+1:p(i+1)-1);
         ind=Lookup2ComponenteComponente(iComponente,id);
         
         %si no encontrado => volver
      	if isempty(ind),return,end
         
         %pasar a un nuevo componente
         iComponente=ind;
      end
      
      %devolver solucion
      resp=iComponente;
      tipo='component';
      return
      
   case 'any'
      %no implementado an
   end
   
case 'component'
   %Inicializar
   iComponente=indice;
   
   %Busqueda de un subcomponente en un componente hacia abajo   
   for i=1:length(p)-1
      id=name(p(i)+1:p(i+1)-1);
      ind=Lookup2ComponenteComponente(iComponente,id);
      
      %si no encontrado => volver
      if isempty(ind),return,end
      
      %pasar al siguiente componente
      iComponente=ind
  	end
      
   %devolver solucion
   resp=iComponente;
   tipo='component';
   return
   
end

%---------------------------------------------------
%Descripcion:
%	Busca una subclase en una clase
function resp=Lookup2ClaseClase(iClase,id)
%declarar ROOT
global ROOT

%Obtener lista de nombres de la clase
hijo=ROOT.clase(iClase).hijo;
resp=hijo(find(strcmp({ROOT.clase(hijo).nombre},id)));
   
%---------------------------------------------------
%Descripcion:
%	Busca un componente en una clase
function resp=Lookup2ClaseComponente(iClase,id)
%declarar ROOT
global ROOT

%Obtener lista de componentes de la clase
icomponente=ROOT.clase(iClase).componente;
resp=icomponente( find(strcmp({ROOT.componente(icomponente).nombre},id)) );

%---------------------------------------------------
%Descripcion:
%	Busca un componente en una componente
function resp=Lookup2ComponenteComponente(iComponente,id)
%declarar ROOT
global ROOT

%Obtener lista de componentes de la clase
hijo=ROOT.componente(iComponente).hijo;
resp=hijo( find(strcmp({ROOT.componente(hijo).nombre},id)) );

