%Entrada:
%	ibloque=indice a bloque dentro de ENTORNO		 
%	nombre=nombre del fichero de la funcion que se va a crear
%	ruta=directorio donde se va a crear la funcion	
%Descripcion:
%	Crea una funcin de la forma y=f(x) para que despues sea llamada para 
%	resolver el sistema f(x)=0
function ConstruirFuncionBloque(ibloque,nombre,ruta)
%declarar ROOT ENTORNO
global ROOT ENTORNO

%Abrir el fichero en modo escritura
fh=fopen([ruta '\' nombre '.m'],'w');
if fh==-1
   ROOT.merr=['$18$' ruta '\' nombre '.m' '$'];
   error(ROOT.merr);
end

%crear la cabecera de la funcion
fprintf(fh,'function y=%s(x,entradas,parametros)\r\n',nombre);

%escribir las constantes
%fprintf(fh,'%%---constantes\r\n');
%iconstantes=ObtenerIndiceVars(ENTORNO.infoVars,'constante');
%for i=1:length(iconstantes)
%   var=ENTORNO.infoVars(iconstantes(i));
%   fprintf(fh,'%s=%d;\r\n',var.sustituida,var.valor);
%end
%fprintf(fh,'\r\n');

%escribir los parametros
fprintf(fh,'%%---parametros\r\n');
iparametros=ObtenerIndiceVars(ENTORNO.infoVars,'parametro');
for i=1:length(iparametros)
   var=ENTORNO.infoVars(iparametros(i));
   fprintf(fh,'%s=parametros(%d);\r\n',var.sustituida,i);
end
fprintf(fh,'\r\n');

%escribir las entradas
fprintf(fh,'%%---entradas al bloque\r\n');
for i=1:length(ENTORNO.bloques(ibloque).entradas)
   var=ENTORNO.infoVars(ENTORNO.bloques(ibloque).entradas(i));
   fprintf(fh,'%s = entradas(%d);\r\n',var.sustituida,i);
end
fprintf(fh,'\r\n');

%escribir las salidas
fprintf(fh,'%%---salidas para la siguiente iteracion\r\n');
for i=1:length(ENTORNO.bloques(ibloque).salidas)
   var=ENTORNO.infoVars(ENTORNO.bloques(ibloque).salidas(i));
   fprintf(fh,'%s = x(%d);\r\n',var.sustituida,i);
end
fprintf(fh,'\r\n');

%escribir las ecuaciones
fprintf(fh,'%%---ecuaciones\r\n');
for i=1:length(ENTORNO.bloques(ibloque).sustituidas)
   fprintf(fh,'y(%d) = %s;\r\n',i,ENTORNO.bloques(ibloque).sustituidas{i});
end
fprintf(fh,'\r\n');

%cerrar el fichero
fclose(fh);