%Entrada:
%	e=estructura ecuacion. Esta estructura contiene todas las ecuaciones
%	v=estructura variables. Esta estructura contiene todas las variables
%%Salida:
%	a=matriz de incidencia
%  d=vector de celdas que contiene el nombre de la variable que corresponde a cada
%		columna de a
%Descripcion:
%	Construye la matriz de incidencia a partir de las ecuaciones y las variables.
function infoMatrizIncidencia=ConstruirMatrizIncidencia(infoVars,ecuaciones)
%declarar ROOT
global ROOT

%incializar
infoMatrizIncidencia=[];

%construir un vector donde se almacenan las variables desconocidas
idesconocidas=ObtenerIndiceVars(infoVars,{'real' 'derivada'});

%inicializar la matriz de incidencia a cero
num_ecuaciones=length(ecuaciones);
num_reales=length(idesconocidas);
if ~num_ecuaciones | ~num_reales | num_ecuaciones ~= num_reales
   ROOT.merr=['$17$' num2str(num_ecuaciones) '$' num2str(num_reales) '$'];
   error(ROOT.merr);
end

%crear la matriz de incidencia
a=zeros(num_ecuaciones,num_reales);

%construir la matriz de incidencia original
for i=1:num_ecuaciones
   for j=1:length(ecuaciones(i).vars)
      columna=BuscarVarVector(idesconocidas,ecuaciones(i).vars(j));
      if ~isempty(columna)
         a(i,columna)=1;
      end
   end
end

%obtener matriz blt
[b,p,q,r,s]=blt(a);

%crear la salida
infoMatrizIncidencia.original=a;
infoMatrizIncidencia.ordenada=b;
infoMatrizIncidencia.nombreColumnasOriginal={infoVars(idesconocidas).expresion};
infoMatrizIncidencia.nombreColumnasOrdenada={infoVars(idesconocidas(q)).expresion};
infoMatrizIncidencia.permEcs=p;
infoMatrizIncidencia.permVars=q;
infoMatrizIncidencia.r=r;
infoMatrizIncidencia.s=s;