%Descripcion:
%	.)Crear ENTORNO.infoVars a partir de las variables de ROOT, declara todas las variables como real
%	.)Inicializa a 0 los parametros y constantes que tiene el valor nan
%	.)Inicializa a 0 las variables reales con start nan
function GenerarEntorno(iClase)
%declarar ROOT
global ROOT ENTORNO

%borrar los indices
clear GenerarNombreVar

%Limpiar ENTORNO
ENTORNO=[];

%aadir el tiempo
ENTORNO.infoVars(1).expresion='time';
ENTORNO.infoVars(1).tipo='conocida';
ENTORNO.infoVars(1).valor=nan;
ENTORNO.infoVars(1).start=nan;
ENTORNO.infoVars(1).fixed=0;
ENTORNO.infoVars(1).sustituida='time';
ENTORNO.infoVars(1).orden=0;
ENTORNO.infoVars(1).expresionSinDerivar='time';

%obtener la clase y los componentes
BuscarVariables(ROOT.clase(iClase).componente,'');
%infoVars=BuscarVariables(ROOT.clase(iClase).componente,'');
%if ~isempty(infoVars)
%	ENTORNO.infoVars(end+1:end+length(infoVars))=infoVars;
%end   

%-------------------------------
%---RECOPILAR LAS ECUACIONES----
%-------------------------------

%recorrer las ecuaciones
if isempty(ROOT.clase(iClase).ecuacion)
   ENTORNO.ecuaciones=[];
else
   %hay que hacerlo as para que funcione bien deal
   ENTORNO.ecuaciones(1).expresion='';
	[ENTORNO.ecuaciones(1:length(ROOT.clase(iClase).ecuacion)).expresion]=deal(ROOT.clase(iClase).ecuacion{:});
end

%-------------------------------
%---RECOPILAR LOS EVENTOS   ----
%-------------------------------

%crear un campo bloques vaco
ENTORNO.bloques=[];

%recorrer los eventos. Slo creamos un evento si tiene asignacion (FUTURO) o reinit
ENTORNO.when=[];
ENTORNO.whennumerocc=0;
indicewhen=1;
for i=1:length(ROOT.clase(iClase).evento)
   %obtener indice de evento
   ievento=ROOT.clase(iClase).evento(i);
   
   %leer el nmero de reinit. Slo se forma un when si tenemos ecuaciones
   num=length(ROOT.when(ievento).reinit);
   if num>0
   	%leer la cc
   	ENTORNO.when(indicewhen).cc=ROOT.when(ievento).cc;   
      
      %incrementar el nmero de cc totales
      ENTORNO.whennumerocc=ENTORNO.whennumerocc+length(ROOT.when(ievento).cc);
      
      %formar los reinit
   	[ENTORNO.when(indicewhen).reinit(1,1:num).miexpresion]=deal(ROOT.when(ievento).reinit.var);
      [ENTORNO.when(indicewhen).reinit(1,1:num).mdexpresion]=deal(ROOT.when(ievento).reinit.expresion);
      
      %incrementar el nmero de evento
      indicewhen=indicewhen+1;
   end     
end

%crear un alias vaco
ENTORNO.alias=[];

%crear los campos donde se almacenan las soluciones
ENTORNO.sol=[];
ENTORNO.t=[];

%-------------------------------------------------------------------------------
%Entrada:
%	iComponente: [indice de los componentes a buscar variables]
%	raizNombre: nombre del componente padre hacia arriba
%Salida:
%	estructura ENTORNO.infoVars rellena (sin derivadas)
%Descripcion:
%	Busca las variables cuyo especificador sea Real
%function infoVars=BuscarVariables(iComponente,raizNombre)
function BuscarVariables(iComponente,raizNombre)
%declarar ROOT ENTORNO
global ROOT ENTORNO

for i=1:length(iComponente)
	%Obtener el componente
	componente=ROOT.componente(iComponente(i));
	prefijo=componente.prefijo;
   especificador=componente.especificador;
   if isempty(raizNombre)
      nombre=componente.nombre;
   else
      nombre=[raizNombre '.' componente.nombre];
   end

	%ver el especificador
	switch especificador
	case 'Boolean'
      %no implementado
      
	case 'Integer'
      %no implementado
      
	case 'Real'
   	%buscar los campo value, start y fixed
   	iValue=LookupComponenteEnComponente(iComponente(i),'value');
   	iStart=LookupComponenteEnComponente(iComponente(i),'start');
		iFixed=LookupComponenteEnComponente(iComponente(i),'fixed');
      
      %poner los valores
      valor=ROOT.componente(iValue).valor;
      start=ROOT.componente(iStart).valor;
      fixed=ROOT.componente(iFixed).valor;
      
   	%almacenarlo en infoVars
   	pos=length(ENTORNO.infoVars)+1;
   	ENTORNO.infoVars(pos).expresion=nombre;
   	switch prefijo
   	case 'constant'
         ENTORNO.infoVars(pos).tipo='constante';
         
         %inicializar valor
         if isnan(valor)
            valor=0;
         end
         
   	case 'parameter'
         ENTORNO.infoVars(pos).tipo='parametro';
         
         %inicializar valor
         if isnan(valor)
            valor=0;
         end
         
   	case 'flow'
         ENTORNO.infoVars(pos).tipo='real';
         
         %inicializar start
         if isnan(start)
            start=0;
         end
         
   	case 'discrete'
      	%no implementado
   	otherwise
         ENTORNO.infoVars(pos).tipo='real';
         
         %inicializar start
         if isnan(start)
            start=0;
         end
   	end
   	ENTORNO.infoVars(pos).valor=valor;
   	ENTORNO.infoVars(pos).start=start;
   	ENTORNO.infoVars(pos).fixed=fixed;
   	ENTORNO.infoVars(pos).sustituida=GenerarNombreVar(ENTORNO.infoVars(pos).tipo);
   	ENTORNO.infoVars(pos).orden=0;
   	ENTORNO.infoVars(pos).expresionSinDerivar=nombre;
   
	case 'String'
   	%no implementado
	otherwise
      %especificador es una clase
      %ninfoVars=BuscarVariables(componente.hijo,nombre);
      BuscarVariables(componente.hijo,nombre);

      
      %agregarla las variables encontradas
      %if isempty(infoVars)
      %   infoVars=ninfoVars;
      %else
      %   infoVars(end+1:end+length(ninfoVars))=ninfoVars;
      %end
	end
end
