function [b,p,q,r,s]=blt(a)
%	 BLT permutation
%   [b,p,q,r,s] = BLT(A) finds a row permutation p and column
%   permutation q so that b=A(p,q) is in block lower triangular form.
%   The outputs r and s are integer vectors describing the boundaries
%   of the blocks:
%   the kth block of A(p,q) has indices (r(k):r(k+1)-1,s(k):s(k+1)-1). 
%   Paco Vzquez, 2002

% Call a function to perform a ulmage-Mendelsohn permutation.
%[p,q,r,s] = sparsfun('dmperm',a'); 
[p,q,r,s] = dmperm(a'); 

% Reorder rows and columns
aux=p;
p=q;
q=aux;
aux=r;
r=s;
s=aux;
b=a(p,q);

