function [y,paso,h]=hnewton_n(fun,iniciox,tol,n,e,p)
%declarar ROOT
global ROOT

%algoritmo
paso=0;
maxpaso=40;
h=1; %incremento de x en el algoritmo
pasoh=0;
maxpasoh=15; %max incremento 1/10^15
while 1
   %iniciar
   nuevax=iniciox;
   
   %calcular solucion
   while 1
   	%siguiente paso
      paso=paso+1;
      if paso>maxpaso
         ROOT.merr='$22$';
         error(ROOT.merr);
      end
   	x=nuevax;
   
   	%calcular f,df para el algoritmo de Euler
   	f=feval(fun,x,e,p);
   	df=jacobiano(fun,x,e,p,0.01,n);
   	b=f/df;
      normaf=norma(f);
      
   	%Calcular el valor adecuado para el incremento
      k=h;
      pasok=pasoh;
      salida=0;
      while 1
         %siguiente paso
         pasok=pasok+1;
         if pasok>maxpasoh
            salida=1;
            break
         end
         
         %siguiente valor de x
      	nuevax=x-k*b;
   
   		%estudiar el error
         nuevaf=feval(fun,nuevax,e,p);
   		if norma(nuevaf)>normaf
      		k=k/10;
   		else 
      		break
   		end
   	end
   
   	%condiciones de salida
      if salida
         break
      elseif norma(nuevax-x)<tol
         %Encontrada la solucion
      	y=nuevax;
      	return
      end   
   end
   
   %siguiente paso
   paso=paso+1;
   if paso>maxpaso
      %y=nuevax;
      ROOT.merr='$22$';
      error(ROOT.merr);
   end
      
   %siguiente paso para h
   pasoh=pasoh+1;
   if pasoh>maxpasoh
      %y=nuevax;
      ROOT.merr='$22$';
      error(ROOT.merr);
   end
   h=h/10;
end

%--------------------------------------------------------------------------------------------------------------------------
function v=norma(x)
v=max(abs(x));