function cad=ParseExpression
cad=simple_expression;

%--------------------------------------------------------------------------------------------------------------------
%Gramatica de una simple_expression
%	simple_expression     --> logical_term {'or' logical_term}
%	logical_term          --> logical_factor {'and' logical_factor}
%	logical_factor        --> [not] relation
%	relation              --> arithmetic_expresion [rel_op arithmetic_expression]
%	arithmetic_expression --> ['+' | '-' ] term {('+' | '-') term}
%	term                  --> factor {( '*' | '/') factor}
%	factor                --> primary ['^' primary]
%  primary	             --> 'entero' | 'real' | 'name' | 'id' | '(' simple_expresion ')' 
%												  | funcion '(' arithmetic_expression ')' | 'der' '(' name ')'
%
%	rel_op --> '<' | '<=' | '>' | '>=' | '==' | '<>'
function cad=simple_expression
%inicializar ROOT
global ROOT

%----------------
%-VERSION ACTUAL-
%----------------
cad=arithmetic_expression;
return

%------------------------
%-PARA FUTURAS VERSIONES-
%------------------------
%Leer el primer logical_term
cad=logical_term;

%Leer {'or' logical_term}
while 1   
   %Leer token, para ver si es or
   [tk,s,linea]=LeerToken;   
   if strcmp(tk,'or')
      %limpiar error
      ROOT.merr='';
      
      %leer otro logical_term
      cad2=logical_term;
            
      %generar la salida
      cad=[cad 'or' cad2];
   else
      LeerToken('unread',tk,s,linea);
      ROOT.merr=[ROOT.merr '@23'];
      return
   end
end

%--------------------------------------------------------------------------------------------------
function cad=logical_term
%inicializar ROOT
global ROOT

%Leer el primer logical_factor 
cad=logical_factor;

while 1   
   %Leer token, para ver si es and
   [tk,s,linea]=LeerToken;   
   if strcmp(tk,'and')
      %limpiar error
      ROOT.merr='';
      
      %Leer otro logical_factor 
      cad2=logical_factor;
                  
      %generar la salida
      cad=[cad 'and' cad2];
   else
      LeerToken('unread',tk,s,linea);
      ROOT.merr=[ROOT.merr '@24'];
      return
   end
end

%--------------------------------------------------------------------------------------------------
function cad=logical_factor
%inicializar ROOT
global ROOT

%leer [not]
[tk,s,linea]=LeerToken;
if strcmp(tk,'not')
   ROOT.merr='';
   cad='not';
else
   LeerToken('unread',tk,s,linea);
   ROOT.merr=[ROOT.merr '@25'];
   cad='';
end

%leer relation
cad=[cad relation];
   
%--------------------------------------------------------------------------------------------------
function cad=relation
%inicializar ROOT
global ROOT

%Leer una expresion aritmtica
cad=arithmetic_expression;

%Ver si viene un operador de relacion
[tk,s,linea]=LeerToken;
switch tk
case {'menor','menorigual','mayor','mayorigual'}
   %limpiar el error
   ROOT.merr='';
   cc=s;   
otherwise
   LeerToken('unread',tk,s,linea);
   ROOT.merr=[ROOT.merr '@26'];
   return
end

%llamar a otra expresion aritmtica
cad2=arithmetic_expression;

%generar salida
cad=[cad cc cad2];

%-----------------------
%-FIN FUTURAS VERSIONES-
%-----------------------

%----------------------------------------------------------------------------------------
function cad=arithmetic_expression
%inicializar ROOT
global ROOT

%Leer [+|-] term
[epsilon,tk,s]=matchEpsilon({'mas' 'menos'},'@27');
if ~epsilon
   signo=s;
else
   signo='';
end

%leer el termino
cad=[signo term];   
   
%leer {add_op term}
while 1
   %leer el operador
   [epsilon,tk,s]=matchEpsilon({'mas' 'menos'},'@27');
   if epsilon,break,end
   op=s;
 
   %leer term
   cad2=term;
   
   %generar salida
   cad=[cad op cad2];
end

%----
function cad=term
%inicializar ROOT
global ROOT

%leer factor
cad=factor;

%leer {mul_op factor}
while 1
   %leer el operador
   [epsilon,tk,s]=matchEpsilon({'por' 'dividir'},'@28');
   if epsilon,break,end
   op=s;
   
   %leer factor
   cad2=factor;
   
   %generar salida
   cad=[cad op cad2];   
end

%----
function cad=factor
%inicializar ROOT
global ROOT

%leer primary
cad=primary;

%leer [^primary]
[epsilon,tk]=matchEpsilon('potencia','@29');
if ~epsilon   
   %leer primary
	cad2=primary;

	%generar salida
	cad=[cad '^' cad2];
end

%----
function cad=primary(varargin)
%inicializar ROOT
global ROOT

%leer token
[tk,s,linea]=LeerToken;
switch tk
case {'entero' 'real' 'name' 'id'}
   %limpiar error
   ROOT.merr='';
   cad=s;   
case 'pabierto' 
   %limpiar error
   ROOT.merr='';
   
   %Leer ( expresion )
  cad=['(' simple_expression ')'];
        
   %leer )
   match('pcerrado','@13');   
   
case 'funcion' 
   %limpiar error
   ROOT.merr='';
   
   %leer funcion(expresion )
   %leer el nombre de la funcion
   fn=s;
   
   %leer (
   match('pabierto','@12');
   
   %leer el contendido del parentesis
   cad=simple_expression;
      
   %leer )
   match('pcerrado','@13');   
      
  	%generar salida   
   cad=[fn '(' cad ')'];
      
case 'der' %leer der(var)
   %limpiar error
   ROOT.merr='';
   
   %leer (
   %leer (
   match('pabierto','@12');
   
   %leer la variable
   [tk,s]=match({'name' 'id'},'@34');
   var=s;
         
   %leer )
   match('pcerrado','@13');   
      
   %generar salida   
   cad=['der(' var ')'];
   
otherwise   
   ROOT.merr=['@' num2str(linea) ROOT.merr '@18@' s];
   error(ROOT.merr);
end
   
