%Entrada:
%	fichero: nombre del fichero donde se va a realizar el parse
%	root: opcional. 
%Salida:
%	iclase: slo cuando modo es 'import' | 'dir'
%Descripcion:
%	Realiza el parse del fichero.
function varargout=Parser(fichero,varargin)
%declarar root como global
global ROOT

%comprobar el nmero de argumentos de entrada
switch nargin
case 1
    %entrada normal
    ROOT=[];
   
    %crear la clase padre de todas
  	ROOT.clase(1).nombre='';
	ROOT.clase(1).prefijo='';
	ROOT.clase(1).tipo='';
	ROOT.clase(1).hijo=[];
	ROOT.clase(1).padre=[];
	ROOT.clase(1).yo=1;
	ROOT.clase(1).instanciada=0;
	ROOT.clase(1).componente=[];
	ROOT.clase(1).ecuacion={};
	ROOT.clase(1).evento=[];
    ROOT.clase(1).conector=[];
    ROOT.clase(1).import=[];
	ROOT.clase(1).restricciones.rsc=0; %solo constantes
	ROOT.clase(1).restricciones.rnc=0; %no conector
	ROOT.clase(1).restricciones.rne=0; %no ecuacion
	ROOT.clase(1).restricciones.rncp=0; %no puede tener componentes protected
    ROOT.clase(1).esPaquete=0;
    ROOT.clase(1).esPartial=0;
    ROOT.clase(1).esImport=0;
   
    %aadir los dems campos
    ROOT.componente=[];
   ROOT.modificacion=[];
   ROOT.when=[];
   ROOT.import=[];
   
   %Crear un componente ficticio, que ser usado por ExtenderClase
   ROOT.componente(1).prefijo='';
   ROOT.componente(1).especificador='';
   ROOT.componente(1).iespecificador=[];
   ROOT.componente(1).nombre='';
   ROOT.componente(1).hijo=[];
   ROOT.componente(1).valor=nan;
   ROOT.componente(1).modificacion=[];
   ROOT.componente(1).almacenado='x';
   ROOT.componente(1).aplicadaModificacion=0;
   ROOT.componente(1).instanciada=1;
  
   %control de errores
   ROOT.merr='';
   
   %clase a compilar
   ROOT.iclase=[];
   
   %pila para controlar la recursion
   ROOT.ppila=0; %puntero pila
   ROOT.maxpila=20; %ultima posicion de la pila
   ROOT.pila=zeros(1,ROOT.maxpila);
   
   %modo para imterpretar el fichero
   modo='root';
   
   %Limpiar LeerToken
   LeerToken('closeall');
case 2
   %procesar la orden 'import' 'dir'
   modo=varargin{1};
end   
   
%abrir fichero
LeerToken('open',fichero);

%interpretar fichero.
if strcmp(modo,'root')
   %no devuelve argumentos
	InterpretarFichero(modo);
else
   %modo 'import' 'dir' devuelve iclases de import
   varargout{1}=InterpretarFichero(modo);
end
   
%cerrar fichero y volver
LeerToken('close');

%----------------------------------------------------------------------------------------------------------------------
%Salida:
%	iclases: [indices de las clases leidas] slo en modo 'import' o 'dir'
function varargout=InterpretarFichero(modo);
%declarar root como global
global ROOT

%interpretar el fichero
iclase=[]; %usado por 'import' 'dir' para almacenar las clases
while 1
    [tk,s,linea]=LeerToken;      
    switch (tk)
    case {'class','connector','model','package','partial','record'}
        %viene una clase
        LeerToken('unread',tk,s,linea);
      
        %interpretar el segn el tipo de modo
        switch modo
        case 'root'
            %las clases cuelgan de la clase 1
            ROOT.clase(1).hijo(end+1)=class_definition(1);
         
        case {'import' 'dir'}
            %las clase no cuelgan de nadie
            iclase(end+1)=class_definition([]);
        end

    case 'fin'
        %eof
        break
      
    otherwise
        ROOT.merr=['@' num2str(linea) ROOT.merr '@1@37@' s];
        error(ROOT.merr);
    end
end

%slo se devuelve salida en modo 'import' | 'dir' 
if any(strcmp({'import' 'dir'},modo))
   varargout{1}=iclase;
end
