%Descripcion:
%	Lee la declaracion de una clase
function lugarClase=class_definition(padre)
%declarar root como global
global ROOT

%inicializar
lugarClase=[];

%restricciones
rsc=0; %1=solo se permiten constantes y clases
rnc=0; %1=no puede ser usado como connect
rne=0; %1=no se permiten ecuaciones
rncp=0;%1=no se permiten componentes protected

%leer [partial]
epsilon=matchEpsilon('partial','@37');
partial=~epsilon;

%Leer el primer token class, connector, model, record
[tk,s,linea]=LeerToken;
switch tk
case 'connector'
   tipo='connector';
   rne=1;
case 'class';
   tipo='class';
case 'model'
   tipo='model';
   rnc=1;
case 'package'
   tipo='package';
   rsc=1;
   rnc=1;
   rne=1;
case 'record'
   tipo='record';
   rnc=1;
   rne=1;
   rncp=1;
%case 'type'
%   tipo='type';
otherwise
   ROOT.merr=['@' num2str(linea) ROOT.merr '@1@' s];
   error(ROOT.merr);
end
%limpiar el error
ROOT.merr='';

%posicion donde se crea la clase
lugarClase=length(ROOT.clase)+1;

%definir la clase
ROOT.clase(lugarClase).nombre='';
ROOT.clase(lugarClase).prefijo='';
ROOT.clase(lugarClase).tipo=tipo;
ROOT.clase(lugarClase).padre=padre;
ROOT.clase(lugarClase).yo=lugarClase;
ROOT.clase(lugarClase).instanciada=0;
ROOT.clase(lugarClase).hijo=[];
ROOT.clase(lugarClase).componente=[];
ROOT.clase(lugarClase).ecuacion={};
ROOT.clase(lugarClase).inicial=[];
ROOT.clase(lugarClase).evento=[];
ROOT.clase(lugarClase).conector=[];
ROOT.clase(lugarClase).import=[];
ROOT.clase(lugarClase).extension=[];
ROOT.clase(lugarClase).restricciones.rsc=rsc;
ROOT.clase(lugarClase).restricciones.rnc=rnc;
ROOT.clase(lugarClase).restricciones.rne=rne;
ROOT.clase(lugarClase).restricciones.rncp=rncp;
ROOT.clase(lugarClase).esPaquete=0;
ROOT.clase(lugarClase).esPartial=partial;
ROOT.clase(lugarClase).esImport=0;	%por defecto todas las clases no son de import

%leer el identificador de la clase y lo guarda
[tk,s]=match('id','@15');
ROOT.clase(lugarClase).nombre=s;
id=s;

%leer un comentario
comment

%leer {element ';'}
while 1
	tk=peek;
	switch tk
	case {'class' 'connector' 'model' 'package' 'record' 'partial'}
   	%crear una nueva clase
      lugarHijo=class_definition(lugarClase);
            
      %clase.clase(end+1)=nuevaClase;
      ROOT.clase(lugarClase).hijo(end+1)=lugarHijo;
      
   case 'import'   
      import_clause(lugarClase);
      
   case 'extends'
      extends_clause(lugarClase);
      
   case {'flow' 'constant' 'parameter' 'id' 'name' 'Real'}
      %crear un componente
      lugarComponente=component_clause;
      
      %agregar las variables a la clase al final
      ROOT.clase(lugarClase).componente(end+1:end+length(lugarComponente))=lugarComponente;
            
   otherwise
      %poner el error
      ROOT.merr=[ROOT.merr '@1@2@3@38@39'];
      break
   end
end

%copiar las clases de importacion en los hijos
numImport=length(ROOT.clase(lugarClase).import);
if numImport>0
	[ROOT.clase(lugarClase).hijo(end+1:end+numImport)]=deal(ROOT.clase(lugarClase).import);
end
   
%leer {equation_clause}
while 1
   tk=peek;
   if strcmp(tk,'equation')
      equation_clause(lugarClase);
   else
      ROOT.merr=[ROOT.merr '@4'];
      break;
   end
end
         
%Leer end id
match('end','@5');
[tk,s,linea]=match('id','@15');
if ~strcmp(id,s)
   error(['#' num2str(linea) '#1']);
end

%Leer ';'
match('puntoycoma','@9');
