%Descripcion:
%	lee una clausula import de la forma:
%	import ( id '=' name | name ) ';' 
function import_clause(iClase)
%declarar ROOT
global ROOT

%leer import
match('import','@38');

%leer id o name
estado=1;
while 1
   [tk,s,linea]=LeerToken;
   switch estado
   case 1
      if strcmp(tk,'id')
         id=s;
         estado=2;
      elseif strcmp(tk,'name')
         name=s;
         
         %obtener donde estn los puntos de name para construir id
         pos=find(name=='.');
         id=name(1:pos(1)-1);
         
         estado=5;
      else
         %error
         ROOT.merr=['@' num2str(linea) '@34@' s];
         error(ROOT.merr);
      end
      
    case 2
       if strcmp(tk,'igual')
         estado=3;
      elseif strcmp(tk,'puntoycoma')
         %crear un import
			CrearImport (iClase,id,id);         
         break;
      else
         %error
         ROOT.merr=['@' num2str(linea) '@9@14@' s];
         error(ROOT.merr);
      end
      
   case 3
      if any(strcmp({'id' 'name'},tk))
         name=s;
         estado=4;
      else
         %error
         ROOT.merr=['@' num2str(linea) '@34@' s];
         error(ROOT.merr);
      end
      
   case 4
		if strcmp(tk,'puntoycoma')
         %crear un import
			CrearImport (iClase,id,name);         
         break;
      else
         %error
         ROOT.merr=['@' num2str(linea) '@9@' s];
         error(ROOT.merr);
      end      
      
   case 5
      if strcmp(tk,'puntoycoma')   
         %crear un import
         CrearImport (iClase,id,name);         
         break;
      else
         %error
         ROOT.merr=['@' num2str(linea) '@9@' s];
         error(ROOT.merr);
      end   
   end
end


%------------------------------------------------------------------------------------------------------------------
%Entrada:
%	iclase: indice de la clase
%	name: nombre de la ruta con id1.id2...idn
%Salida:
%	iimport: indice de import
function CrearImport(iClase,cualificador,nombre)
%declarar ROOT
global ROOT

%Buscar name en import
if ~isempty(ROOT.import)
   iimport=find(strcmp({ROOT.import.nombre},nombre));   
else
   iimport=[];
end

if isempty(iimport)
	%-----------------------
	%--- CREAR UN NUEVO  ---
	%----    IMPORT      ---
	%-----------------------

	%calcular ruta
	ruta=[Registro('recuperar','dirlibreria') strrep(nombre,'.','\') '.moo'];

	%realizar el anlisis sintctico del import
	iNuevaClase=Parser(ruta,'import');

	%si fichero vaco => volver
	if isempty(iNuevaClase),return,end

	%si hay mas de una clase=>volver
	if length(iNuevaClase)>1
   	ROOT.merr=['$20$' ROOT.clase(iClase).nombre '$' nombre '$'];
   	error(ROOT.merr);
	end

	%indice donde guardar la info
	iimport=length(ROOT.import)+1;
	ROOT.import(iimport).ruta=ruta;
	ROOT.import(iimport).nombre=nombre;
	ROOT.import(iimport).clase=iNuevaClase;

	%poner el indicador de clases import
	ROOT.clase(iNuevaClase).esImport=1;
end

%duplicar la clase cambiando el nombre por el cualificador
iNuevaClase=ROOT.import(iimport).clase;
nc=length(ROOT.clase)+1;
ROOT.clase(nc)=ROOT.clase(iNuevaClase);
ROOT.clase(nc).nombre=cualificador;
ROOT.clase(nc).padre=iClase;
ROOT.clase(nc).esImport=0;

%guardar la referencia de nc en la iClase
ROOT.clase(iClase).import(end+1)=nc;