%--------------------------------------------------------------------------------------------------------
%Salida:
%	iModificacion= indice a ROOT.modificacion. Los campos son los siguientes:
%						Para class_modification ['=' expresion]
%							modificacion.expresion= expresion | ''
%							modificacion.valor=nan
%							modificaion.argumento=argumento devuelto por la funcion class_modificacion
%						Para =expresion
%							modificacion.expresion=expresion
%							modificacion.valor=nan
%							modificacion.argumento=[]
%  
%Descripcion:
%	Interpreta la regla:
%		modification--> class_modification ['=' expresion]
%							 '=' expresion 
function iModificacion=modification
%declarar root como global
global ROOT

%interpretar
[tk,s,linea]=peek;
if strcmp(tk,'pabierto')
   %ejecutar class_modification
   iModificacion=class_modification;
   
   %leer ['=' expresion]
   epsilon=matchEpsilon('igual','@14');
   if ~epsilon
   	%Crear modificacion
	   if isempty(iModificacion)
	      iModificacion=length(ROOT.modificacion)+1;
         ROOT.modificacion(iModificacion).valor=nan;
   		ROOT.modificacion(iModificacion).argumento=[];
      end
      
      %poner expresion   
      ROOT.modificacion(iModificacion).expresion=ParseExpression;;
   end
   
elseif strcmp(tk,'igual')
   %leer =expresion
   match('igual','@14');
   
   %leer expresion
   expresion=ParseExpression;
   
   %Crear modificacion
   iModificacion=length(ROOT.modificacion)+1;
   ROOT.modificacion(iModificacion).expresion=expresion;
   ROOT.modificacion(iModificacion).valor=nan;
   ROOT.modificacion(iModificacion).argumento=[];
   
else
   %error
   ROOT.merr=['@' num2str(linea) ROOT.merr '@21@' s];
   error(ROOT.merr);
end