%Entrada:
%	maq:nmero de mquina
%	linea: nmero de lnea donde se ha producido el error
%	nerr: nmero de error o []
%Descripcion:
%	muestra un mensaje de error
%	
function GestionErrores
%tipos de tokens esperados. usado por Parser
primero={' class model record connector package',...
      	' flow parameter constant',...
      	' id name Real',...
         ' equation',...
         ' end',...
         ' end when',...
         ' when',...
         ' then',...
         ' ;',...
         ' ,',...
         ' +',...
         ' (',...
         ' )',...
         ' =',...
         ' id',...
         ' cadena',...
         ' name',...
         ' entero real name id ( funcion der',...
         ' entero real name id ( funcion der + -',...
         ' entero real name id ( funcion der + -'... %FUTURA VERSION:' entero real name id ( funcion der + - not',...
         ' ( =',...
         ' id name',...
         ' or',...
         ' and',...
         ' not',...
         ' < <= > >=',... %FUTURA VERSION: ' < <= > >= == <>',...
         ' + -'...
         ' * /'...
         ' ^'...
         ' connect'...
         ' entero real name id ( funcion der + - {'...
         ' }'...
         ' reinit'...
         ' id name'...
         ' elsewhen'...
         ' {'...
         ' partial'...
         ' import'...
         ' extends'...
      };
   
%mensajes de error. Usado por LeerToken y Parser
mensaje={' el identificador de la clase no coincide con el de end',...
      	' las referencias a conector son iguales',...
      	' referencia a conector no valida',...
         ' error al abrir el fichero: ',...
         ' error al cerrar el fichero: ',...
         ' error al cerrar los ficheros: ',...
         ' se esperaba */',...
         ' se esperaba letra, nummero, _',...
         ' caracter no valido: ',...
         ' se esperaba +, -, digito',...
         ' se esperaba un entero despues de +, -',...
         ' se esperaba "'...
      	' error interno en: '
   };
   
%mensajes de error en las clases. Usado por Flattening, Instanciar y funciones que generan el cdigo
menClase={ {'En la clase ' ' la variable ' ' de la ecuacion ' ' no est declarada '}...
      {'En la clase ' ' la variable ' ' est declarada varias veces '}...
      {'En la clase ' ' el especificador ' ' no est declarado '}...
		{'En la clase ' ' la variable ' ' no est declarada '}...
		{'En la clase ' ' el especificador ' ' no es de tipo connector '}...
		{'En la clase ' ' los conectores ' ' no son compatibles '}...
		{'En la clase ' ' el componente ' ' no se ha encontrado '}...
		{'En la clase ' ' el componente ' ' es de tipo ' ' y el valor asignado es de tipo '}...
		{'En la clase ' ' el componente ' ' ha sido asignado varias veces '}...
		{'En la clase ' ' el componente ' ' ha obtenido divisin por cero en su asignacion '}...
		{'En la clase ' ' en el componente ' ' en su asignacion slo se permite constantes y parametros '}...
      {'En la clase ' ' en el componente ' ' no es valida su asignacion '}...
      {'En la clase ' ' se han definido dos ecuaciones de alias incompatibles '}...
      {'En la clase ' ' se han definido dos variables de alias con tipos incompatibles '}...
      {'En la clase ' ' se han definido dos variables de estado como alias incompatibles '}...
      {'No se ha seleccionado ninguna clase para compilar'}...
      {'La Matriz de incidencia es singular. Numero de ecuaciones: ' ' Numero de incgnitas '}...
      {'Error al abrir el fichero: '}...
      {'En la clase ' ' la variable ' ' no es de estado '}...
      {'En la clase ' ' el import' ' contiene mas de una clase '}...
      {'Las clases ' ' y ' ' tienen el componente ' ' que no es compatible '}...
      {'El sistema no converge '}...
      {'En la clase ' ' se ha definido una ecuacin de alias incompatible ' }...
      {'En la clase ' ' se han definido dos variables de alias incompatibles ' ' y '}...
      {'Se ha alcanzado el limite mximo de recursion en Flattening. Posiblemente haya una dependencia circular entre clases: '}...
	};
   
%leer el error
err=lasterr;

%ver si es un error del sistema
%ind=Substr({'Syntax' 'Unable' 'Undefined' 'Too many' 'Improper' 'Cell' 'Missing'},err);
%if ~isempty(ind)
%   error(err);
%   return
%end

%quitar char(10) del mensaje de error
err(end-1:end)=[];

%leer el mensaje
pos1=find(err=='#');
pos2=find(err=='@');
pos3=find(err=='$');

%gestiona el error
if ~isempty(pos1)
   %leer mensaje
   if length(pos1)==2
   	linea=err(pos1(1)+1:pos1(2)-1);
      nerr=str2num(err(pos1(2)+1:end));
      s='';
   else
      linea=err(pos1(1)+1:pos1(2)-1);
      nerr=str2num(err(pos1(2)+1:pos1(3)-1));
      s=err(pos1(3)+1:end);
   end
   merr={['En el fichero: ' LeerToken('name')]...
         ['linea: ' linea mensaje{nerr} s]};
elseif  ~isempty(pos2)
   %ver si viene mensaje 
   if pos2(end)==length(err)
      s='';
   else
      s=err(pos2(end)+1:end);
   end
   
   %leer la linea
   linea=err(pos2(1)+1:pos2(2)-1);
   
   %leer el cuerpo del mensaje
   cuerpo=[];
   for i=2:length(pos2)-1
      nerr=str2num(err(pos2(i)+1:pos2(i+1)-1));
      cuerpo=[cuerpo primero{nerr}];
   end
   
   %construir el mensaje
   if isempty(s)
      merr={['En el fichero: ' LeerToken('name')]...
            ['linea: ' linea ' se esperaba:' cuerpo]};
   else
      merr={['En el fichero: ' LeerToken('name')]...
         	['En linea: ' linea ' se encontro: ' s] ...
            ['Se esperaba: ' cuerpo]};
   end
elseif ~isempty(pos3)
   %mensaje de clase
   nerr=str2num(err(pos3(1)+1:pos3(2)-1));
   
   %modificar pos3
   pos3(1)=[];
   
   %formar el mensaje de error
   lista=menClase{nerr};
   merr={};
   for i=1:length(pos3)-1
      merr{i}=[lista{i} err(pos3(i)+1:pos3(i+1)-1)];
   end   
   if length(lista)>=length(pos3)
      merr{end+1}=lista{end};
   end
   
   %Leer el nombre del fichero, si todava est abierto
   nombreFichero=LeerToken('name');
   if ~isempty(nombreFichero)
      merr={['En el fichero: ' nombreFichero] merr};
   end
else
   %error del sistema
   error(lasterr);
   return
end
         
%mostrar mensaje
errordlg(merr,'ERROR!');

%----------------------------------------------------------------------------------------------------------------
function ind=Substr(lista,s)
ind=[];
for i=1:length(lista)
   if ~isempty(findstr(lista{i},s))
      ind=i;
      return
   end
end

      