%Entrada:
%	entorno: estructura entorno
%	tipo: tipo de variables a obtener
%Salida:
%	lista: lista del nombre de las variables
%Descripcion:
%	Obtiene el nombre de las variables de un tipo determinado
function varargout=ObtenerListaVars(entorno,tipo,varargin)
%si tipo es cadena, convertirlo en celda
if ischar(tipo)
   tipo={tipo};
end

%Obtener las variables
indices=[];
for i=1:length(tipo) 
   %buscar indice del tipo 'tipo'
   ind=find(strcmp({entorno.infoVars.tipo},tipo{i}));

	%copiar los ndices
	if ~isempty(ind)
      indices(end+1:end+length(ind))=ind;
   end
end
	
%generar la salida
if nargin==2 | (nargin==3 & strcmp(varargin{1},'expresion'))
   varargout{1}={entorno.infoVars(indices).expresion};
elseif nargin==3 & strcmp(varargin{1},'sustituida')
	varargout{1}={entorno.infoVars(indices).sustituida};
elseif nargin==3 & strcmp(varargin{1},'ambas')
   varargout{1}={entorno.infoVars(indices).expresion};
	varargout{2}={entorno.infoVars(indices).sustituida};
else
   varargout{1}=[];
end
