%Token Lee los tokens de una expresin aritmtica bien formada
%
%Sintaxis:
%   varargout=Token(varargin)
%
%Entrada:
%
%Descripcion:
%	Lee los tokens de una expresion aritmetica bien formada
%

%REVISION
%   
function varargout=Token(varargin)
persistent cadena

%grabar datos
if nargin>0
   orden=varargin{1};
   
   %interpretar orden
   switch orden
   case 'open'
      pos=length(cadena)+1;
      cadena(pos).buffer=[varargin{2} 0]; %aadir 0 como fin de cadena
      cadena(pos).posicion=1;
      cadena(pos).tk=[];
      cadena(pos).s=[];
      return
      
   case 'close'   
      cadena(end)=[];
      return
      
   case 'unread'
      cadena(end).tk=varargin{2};
      cadena(end).s=varargin{3};
      return
   end      
end

%ver si ya hay un token unread
if ~isempty(cadena(end).tk)
   varargout{1}=cadena(end).tk;
   varargout{2}=cadena(end).s;
   
   cadena(end).tk=[];
   cadena(end).s=[];
   return
end

%obtener tokens cadena
buffer=cadena(end).buffer;
posicion=cadena(end).posicion;
while 1
   inicio=posicion;
   c=buffer(posicion);
   if ~c
      %fin de la cadena
      varargout{1}='fin';
      varargout{2}='';
      cadena(end).posicion=posicion;
      return
   end
   
   %procesar el caracter
   switch c
   case ' '
      %no hacer nada
      posicion=posicion+1;
   case '+'
      varargout{1}='mas';
      varargout{2}='+';
      cadena(end).posicion=posicion+1;
      return
   case '-'
      varargout{1}='menos';
      varargout{2}='-';
      cadena(end).posicion=posicion+1;
      return
   case '*'
      varargout{1}='por';
      varargout{2}='*';
      cadena(end).posicion=posicion+1;
      return
   case '/'
      varargout{1}='dividir';
      varargout{2}='/';
      cadena(end).posicion=posicion+1;
      return
   case '^'
      varargout{1}='potencia';
      varargout{2}='^';
      cadena(end).posicion=posicion+1;
      return
   case '('
      varargout{1}='pabierto';
      varargout{2}='(';
      cadena(end).posicion=posicion+1;
      return
   case ')'
      varargout{1}='pcerrado';
      varargout{2}=')';
      cadena(end).posicion=posicion+1;
      return
   case '='
      varargout{1}='igual';
      varargout{2}='=';
		cadena(end).posicion=posicion+1;
		return    
   otherwise
      if isletter(c)
         %leer id1.id2.id3...idn
         while isletter(c) || c=='_' || c=='.' || (c>='0' && c<='9')
            posicion=posicion+1;
            c=buffer(posicion);
         end
         s=buffer(inicio:posicion-1);
         
         %ver si es una funcion
         switch s
         case {'sin','cos','tan','arcsin','arccos','arctan','sinh','cosh','tanh','arcsinh','arccosh',...
               	   'arctanh','exp','log','log10','sqrt'}
               varargout{1}='funcion';
         case 'der'
         		varargout{1}='der';      
         otherwise
            varargout{1}='name';
         end
         
         %volver
         varargout{2}=s;
         cadena(end).posicion=posicion;
         return
         
      elseif c>='0' && c<='9'
         %leer un entero o real
         estado=1;
         varargout{1}='entero';
         while 1
            switch estado
            case 1
               if c>='0' && c<='9'
                  estado=1;
               elseif c=='.'
                  varargout{1}='real';
                  estado=2;
               elseif c=='e' || c=='E'
                  varargout{1}='real';
                  estado=3;
               else
                  break
               end
               
            case 2
               if c>='0' && c<='9'
                  estado=2;
               elseif c=='e' || c=='E'
                  estado=3;
               else
                  break
               end
               
            case 3
               if c=='+' || c=='-'
                  estado=4;
               elseif c>='0' && c<='9'
                  estado=4;
               else
                  %no se puede dar nunca esto. porque la expresion
                  %est bien formada
                  break
               end
               
            case 4
               if c>='0' && c<='9'
                  estado=4;
               else
                  break
               end
            end
            %leer siguiente char
            posicion=posicion+1;
            c=buffer(posicion);
         end
         
         %volver
         cadena(end).posicion=posicion;
         varargout{2}=buffer(inicio:posicion-1);
         return
      end
   end
end   