function VerRootFichero(fichero,varargin)
%declarar ROOT
global ROOT

%abrir el fichero
fh=fopen(fichero,'w');
if fh==-1
  disp(['No se ha podido abrir el fichero: ' fichero]);
end

%mostrar clases
if nargin==1
   %mostar todas las clases que cuelgan de la raiz
	for i=1:length(ROOT.clase(1).hijo)
   	MostrarClase(fh,ROOT.clase(1).hijo(i),0);
   end
elseif nargin==2
   %mostrar solo una clase
   MostrarClase(fh,varargin{1},0);
end

%cerrar fichero
fclose(fh);

%--------------------------------------------------------------------------------------------------------------------------
function MostrarClase(fh,lugarClase,sangrado)
%declarar ROOT
global ROOT

%Crear la cadena de sangrado
cadena=char(32*ones(1,sangrado));
   
%Mostrar la info
fprintf(fh,[cadena 'Nombre: ' ROOT.clase(lugarClase).nombre '\n']);
fprintf(fh,[cadena 'Tipo: ' ROOT.clase(lugarClase).tipo '\n']);
fprintf(fh,[cadena 'Padre: ' num2str(ROOT.clase(lugarClase).padre) '\n']);
fprintf(fh,[cadena 'Yo: ' num2str(ROOT.clase(lugarClase).yo) '\n']);
fprintf(fh,[cadena 'Instanciada:' num2str(ROOT.clase(lugarClase).instanciada) '\n']);
fprintf(fh,[cadena 'Clases: ' '\n']);
for i=1:length(ROOT.clase(lugarClase).hijo)
   MostrarClase(fh,ROOT.clase(lugarClase).hijo(i),length('Clases: ')+sangrado);
end
fprintf(fh,[cadena 'Variables: ' '\n']);
MostrarComponente(fh,ROOT.clase(lugarClase).componente,length('Variables: ')+sangrado);   

%---------------------------------------------------------------------------------------------------------------------------
function MostrarComponente(fh,lugarComponente,sangrado)
%declarar ROOT
global ROOT

%crear sangrado
cadena=char(32*ones(1,sangrado));

%ver variables
for i=1:length(lugarComponente)
   fprintf(fh,[cadena 'prefijo: ' ROOT.componente(lugarComponente(i)).prefijo '\n']);
   fprintf(fh,[cadena 'especificador: ' ROOT.componente(lugarComponente(i)).especificador '\n']);
   fprintf(fh,[cadena 'nombre: ' ROOT.componente(lugarComponente(i)).nombre '\n']);
   fprintf(fh,[cadena 'almacenado: ' num2str(ROOT.componente(lugarComponente(i)).almacenado) '\n']);
   fprintf(fh,[cadena 'valor: ' num2str(ROOT.componente(lugarComponente(i)).valor) '\n']);
   fprintf(fh,[cadena 'instanciada: ' num2str(ROOT.componente(lugarComponente(i)).instanciada) '\n']);
   fprintf(fh,[cadena 'aplicadaModificacion: ' num2str(ROOT.componente(lugarComponente(i)).aplicadaModificacion) '\n']);
   fprintf(fh,[cadena 'modificacion: ' '\n']);
   MostrarModificacion(fh,ROOT.componente(lugarComponente(i)).modificacion,sangrado+3,3);
   fprintf(fh,[cadena 'campos: ' '\n']);
   MostrarComponente(fh,ROOT.componente(lugarComponente(i)).hijo,sangrado+length('campos')+3);
   fprintf(fh,'\n');
end

%----------------------------------------------------------------------------------------------------------------
function MostrarModificacion(fh,lugarModificacion,sangrado,desplz)
%declarar ROOT
global ROOT

if ~isempty(lugarModificacion)
	%ver modificacion
	fprintf(fh,[char(32*ones(1,sangrado)) 'expresion: ' num2str(ROOT.modificacion(lugarModificacion).expresion) '\n']);
	for i=1:length(ROOT.modificacion(lugarModificacion).argumento)
      fprintf(fh,[char(32*ones(1,sangrado+desplz)) 'referencia: ' ...
            ROOT.modificacion(lugarModificacion).argumento(i).referencia '\n']);
      MostrarModificacion(fh,ROOT.modificacion(lugarModificacion).argumento(i).modificacion,...
         sangrado+desplz,desplz);
	end
end
