%Entrada:
%Salida:
%Descripcion:
function verEntornoFichero(ver)
%declarar ENTORNO
global ENTORNO

%abrir fichero
fd=fopen([Registro('recuperar','ruta') 'salida.txt'],'w');
if fd==-1,return,end

%procesar el ENTORNO
for i=1:length(ver)
   switch lower(ver(i))
   case 'e'
      %mostrar las ecuaciones
      fprintf(fd,'Ecuaciones\r\n');
      fprintf(fd,'----------\r\n');
      if isfield(ENTORNO,'ecuaciones')
      	for j=1:length(ENTORNO.ecuaciones)
            fprintf(fd,'expresion: %s\r\n',ENTORNO.ecuaciones(j).expresion);
            fprintf(fd,'sustituida: %s\r\n',ENTORNO.ecuaciones(j).sustituida);
            fprintf(fd,'vars: %s\r\n',num2str(ENTORNO.ecuaciones(j).vars));
            fprintf(fd,'lvars1: %s\r\n',Lista2Cadena(ENTORNO.ecuaciones(j).lvars1));
            fprintf(fd,'lvars2: %s\r\n\r\n',Lista2Cadena(ENTORNO.ecuaciones(j).lvars2));            
         end
      end
      fprintf(fd,'\r\n');
      
   case 'i'
      %infoVars
      fprintf(fd,'infoVars\r\n');
      fprintf(fd,'--------\r\n');
      if isfield(ENTORNO,'infoVars')
      	for j=1:length(ENTORNO.infoVars)
            fprintf(fd,'expresion: %s\r\n', ENTORNO.infoVars(j).expresion);
            fprintf(fd,'sustituida: %s\r\n',ENTORNO.infoVars(j).sustituida);
            fprintf(fd,'tipo: %s\r\n',ENTORNO.infoVars(j).tipo);            
            fprintf(fd,'valor: %s\r\n',num2str(ENTORNO.infoVars(j).valor));
            fprintf(fd,'start: %s\r\n',num2str(ENTORNO.infoVars(j).start));                                    
            fprintf(fd,'fixed: %s\r\n\r\n',num2str(ENTORNO.infoVars(j).fixed));
         end
      end
      fprintf(fd,'\r\n');      
      
   case 'a'
      %alias
      fprintf(fd,'alias\r\n');
      fprintf(fd,'-----\r\n');
      if isfield(ENTORNO,'alias')
         for j=1:length(ENTORNO.alias)
            fprintf(fd,'ivars: %s\r\n',num2str(ENTORNO.alias(j).ivars));
            fprintf(fd,'tipo: %s\r\n',ENTORNO.alias(j).tipo);
            if isempty(ENTORNO.alias(j).isust)
               s='[ ]';
            else
               s=num2str(ENTORNO.alias(j).isust);
            end
            fprintf(fd,'isust: %s\r\n',s);
            fprintf(fd,'valor: %s\r\n\r\n',num2str(ENTORNO.alias(j).valor));
         end
      end
      fprintf(fd,'\r\n');
      
   case 'm'
      %matriz de incidencia
      fprintf(fd,'infoMatrizIncidencia\r\n');
      fprintf(fd,'--------------------\r\n');
      if isfield(ENTORNO,'infoMatrizIncidencia')
         fprintf(fd,'tamao: %d x %d\r\n',size(ENTORNO.infoMatrizIncidencia.original,1),...
            size(ENTORNO.infoMatrizIncidencia.original,1));
         fprintf(fd,'original: \r\n%s\r\n',Matriz2Cadena(ENTORNO.infoMatrizIncidencia.original));
         fprintf(fd,'ordenada: \r\n%s\r\n',Matriz2Cadena(ENTORNO.infoMatrizIncidencia.ordenada));
      end
      fprintf(fd,'\r\n');
      
   case 'b'
      %bloques
      fprintf(fd,'Bloques\r\n');
      fprintf(fd,'-------\r\n');
      if isfield(ENTORNO,'bloques')
         for j=1:length(ENTORNO.bloques)
            fprintf(fd,'entradas: %s\r\n',num2str(ENTORNO.bloques(j).entradas));
            fprintf(fd,'salidas: %s\r\n',num2str(ENTORNO.bloques(j).salidas));
            fprintf(fd,'tipo: %s\r\n',ENTORNO.bloques(j).tipo);
            for k=1:length(ENTORNO.bloques(j).sustituidas)
               fprintf(fd,'sustituidas(%d): %s\r\n',k,ENTORNO.bloques(j).sustituidas{k});
            end
            fprintf(fd,'\r\n');
         end
      end
      fprintf(fd,'\r\n');
      
   case 'v'
      %eventos
      fprintf(fd,'Eventos\r\n');
      fprintf(fd,'-------\r\n');
      if isfield(ENTORNO,'when')
         for j=1:length(ENTORNO.when)
            fprintf(fd,'evento nmero: %d\r\n',j);
            
            %escribir condiciones
            for k=1:length(ENTORNO.when(j).cc)
               s=ENTORNO.when(j).cc(k).mi;
               switch ENTORNO.when(j).cc(k).op
               case 'mayor'
                  s=[s '>'];
               case 'menor'
                  s=[s '<'];
               case 'mayorigual'
                  s=[s '>='];
               case 'menorigual'
                  s=[s '<='];
               end
               s=[s ENTORNO.when(j).cc(k).md];
               fprintf(fd,'   condicion nmero: %d   %s   (%s)\r\n',k,s,ENTORNO.when(j).cc(k).sustituida);
           end
               
           %escribir ecuaciones
           for k=1:length(ENTORNO.when(j).reinit)
              fprintf(fd,'   reinit nmero: %d   reinit(%s,%s)   (%s=%s)\r\n',k,ENTORNO.when(j).reinit(k).miexpresion...
                 ,ENTORNO.when(j).reinit(k).mdexpresion,ENTORNO.when(j).reinit(k).misustituida...
                 ,ENTORNO.when(j).reinit(k).mdsustituida);
           end %for k
        end %for j
     end %if
  end %switch
end %for i

%cerrar el fichero
fclose(fd);

%------------------------------------------------------------------------
function s=Lista2Cadena(lista)
s='';
for i=1:length(lista)
   var=[lista{i} ' '];
   s(end+1:end+length(var))=var;
end

%------------------------------------------------------------------------
function s=Matriz2Cadena(m)
s='';
for i=1:size(m,1)
   var=[num2str(m(i,:)) char(13) char(10)];
   s(end+1:end+length(var))=var;
end
