package mecanica

	connector puerto
		flow Real F;
		Real x;
	end puerto;
	
	partial class muelle
		parameter Real k=0.5;
		puerto p1,p2;
		Real x1,x2,F1,F2;
	equation
		F1=-k*(x1-x2);
		F2=-F1;
		p1.x=x1;
		p1.F=F1;
		p2.x=x2;
		p2.F=F2;
	end muelle;
	
	partial class viscoso
		parameter Real b=0.5;
		puerto p1,p2;
		Real x1,x2,v1,v2,F1,F2;
	equation
		F1=-b*(v1-v2);
		F2=-F1;
		p1.x=x1;
		p1.F=F1;
		p2.x=x2;
		p2.F=F2;
		der(x1)=v1;
		der(x2)=v2;
	end viscoso;

	partial class masa2
		parameter Real m=1;
		puerto p1,p2;
		Real x,v,a,F1,F2;
	equation
		F1+F2=m*a;
		p1.x=x;
		-p1.F=F1;
		p2.x=x;
		-p2.F=F2;
		der(x)=v;
		der(v)=a;
	end masa2;

	partial class masa1
		parameter Real m=1;
		puerto p1;
		Real x,v,a,F1;
	equation
		F1=m*a;
		p1.x=x;
		-p1.F=F1;
		der(x)=v;
		der(v)=a;
	end masa1;

	partial class pared
		parameter Real x0=0;
		puerto p1;
		Real x,F;
	equation
		x=x0;
		p1.x=x;
		-p1.F=F;
	end pared;

	partial class fuerzak
		parameter Real k=0;
		puerto p1;
		Real x,F;
	equation
		F=k;
		p1.x=x;
		p1.F=F;
	end fuerzak;
	
	partial class fuerza
		puerto p1;
		Real x,F;
	equation
		p1.x=x;
		p1.F=F;
	end fuerza;
	
end mecanica;